#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* new_AnyWindow(void)
{
    AnyWindow* any;

    if((any = (AnyWindow *)new_WinObj()) == NULL)
	return NULL;

    any->type = Any_T;
    any->ext_id = 0;
    any->ext_data = NULL;
    any->disp = NULL;
    any->win = None;
    any->x = 0;
    any->y = 0;
    any->width = 1;
    any->height = 1;	/* Window geometory */
    any->gc = NULL;
    any->fg = 1;
    any->bg = 0;
    any->lbg = 1;
    any->hbg = 0;
    any->mark_color = 0;
    any->event_mask = 0;
    any->call_back_proc = NULL;
    any->event_handler = NULL;
    any->parent = NULL;
    any->border_skeleton = NULL;
    any->event_alias = NULL;
    any->children = NULL;
    any->winobj_destruction_hook = NULL;
    any->winobj_destruction = NULL;
    any->winobj_resize_proc = NULL;
    any->mono_color = False;
    any->when_realize_mapping = True;
    any->realized_flag = False;

    return (WinObj *)any;
}

WinObj* create_AnyWindow(WinObj* parent, int x, int y, int width, int height)
{
    AnyWindow* p = (AnyWindow *)parent;
    AnyWindow* any = (AnyWindow *)new_AnyWindow();

    if(any == NULL)
	return NULL;

    if(parent != NULL)
    {
	WinObjList* child;

	child = (WinObjList *)winobj_malloc(sizeof(WinObjList));
	if(child == NULL)
	{
	    CallWinObjSysErrorHandler(NULL);
	    DestroyWinObj((WinObj *)any);
	    return NULL;
	}

	child->next = parent->any.children;
	child->obj = (WinObj *)any;

	parent->any.children = child;
    }

    any->type = Any_T;
    any->disp = p->disp;
    any->win = CreateWindow(p->disp, p->win, x, y, width, height, p->bg);
    any->x = x;
    any->y = y;
    any->width = width;
    any->height = height;
    any->gc = p->gc;
    any->fg = p->fg;
    any->bg = p->bg;
    any->lbg = p->lbg;
    any->hbg = p->hbg;
    any->mark_color = p->mark_color;
    any->parent = parent;
    any->mono_color = p->mono_color;

    return (WinObj *)any;
}
