#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* create_SimpleWindow(WinObj* parent,
			    int x,
			    int y,
			    int width,
			    int height,
			    int bd_width,
			    int border_style)
{
    WinObj* border;
    WinObj* s;

    if((border = create_BorderSkeleton(parent, x, y, width, height,
				       bd_width, border_style)) == NULL)
	return NULL;

    if((s = create_AnyWindow((WinObj *)border,
			     bd_width, bd_width, width, height)) == NULL)
    {
	DestroyWinObj(border);
	return NULL;
    }

    s->any.type = Simple_T;
    s->any.border_skeleton = (BorderSkeleton *)border;

    return s;
}
