#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

static void redraw_trig_button(IconButton* icon, Bool pressd)
{
    TrigButton* tb = (TrigButton *)icon;
    double r = MIN(tb->width, tb->height) / 2 - 1;
    Pixel bg;

    if(pressd)
	bg = tb->mark_color;
    else
	bg = tb->bg;

    DrawTriangle(tb->disp, tb->win, tb->gc, tb->width / 2, tb->height / 2,
		 tb->bd_width, r, tb->dist, bg, tb->lbg, tb->hbg, !pressd);
}

WinObj* create_TrigButton(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  double dist)
{
    TrigButton* tb = (TrigButton *)
	create_IconButton(parent, x, y, width, height, 0, None, None, 0, 0);
    if(tb == NULL)
	return NULL;

    tb->type = TrigButton_T;
    tb->redraw_proc = redraw_trig_button;
    tb->dist = dist;
    tb->bd_width = bd_width;

    return (WinObj *)tb;
}

void SetPressdTrigButton(WinObj* tb, Bool pressd)
{
    SetPressdIconButton(tb, pressd);
}
