#ifndef ___WINOBJ_H_
#define ___WINOBJ_H_

#include "winobj_defs.h"
#include "xmisc.h"

union _WinObj;
typedef void (* call_back_t)(union _WinObj*, XEvent*);

/* WinObj Υפɽޤ */
enum winobj_types
{
    Any_T,
    Simple_T,
    BorderSkeleton_T,
    LabeldWindow_T,
    Button_T,
    ARButton_T,
    IconButton_T,
    TrigButton_T,
    HScrollbar_T,
    LineText_T,
    DirLineText_T,
    NamedHScrollbar_T,
    PopupMenuBase_T,
    PopupMenu_T,
    DrawerPopupMenu_T,
    MCPopupMenu_T,
    MenuBar_T,
    SelectMenu_T,
    HAdjustGear_T,
    VAdjustGear_T,
    ChoiceButton_T,
    HSimpleSlider_T,
    HLimitedSlider_T,
    MessageDialog_T,
    QueryYesNo_T,
    GraphPanel_T,
    LastWinObj_T
};

/* ǥץ쥤ηɽޤ */
enum display_visual_types
{
    DISPLAY_VISUAL_DEFAULT,	/* ǥեȤ˱褤ޤ */
    DISPLAY_VISUAL_MONO		/* ˶ޤ */
};

/* Ȥηɽޤ*/
enum winobj_border_styles
{
    WINOBJ_BORDER_NONE,
    WINOBJ_BORDER_NORMAL,
    WINOBJ_BORDER_CONVEX,
    WINOBJ_BORDER_CONCAVE,
    WINOBJ_NUMBER_OF_BORDER
};

/* 顼ɤǤ1000 ̤ͤϥƥॳطΥ顼ɤǤ*/
enum winobj_error_codes
{
    WOE_MIN_ERROR_CODE = 1000,
    WOE_TOO_MANY_OPEN_DISPLAY,
    WOE_TOO_MANY_HANDLER,
    WOE_CANT_GRAB_POINTER,
    WOE_CANT_GET_HOME,
    WOE_UNKNOWN_USER_NAME,
    WOE_FNAME_TOO_LONG
};

typedef struct _AnyWindow
{
#include "anywin.def"

} AnyWindow;

typedef struct _SimpleWindow
{
#ifndef DEPEND
#include "anywin.def"
#endif

} SimpleWindow;

typedef struct _BorderSkeleton
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int bd_width;
    int style;
} BorderSkeleton;

typedef struct _LabeldWindow
{
#ifndef DEPEND
#include "anywin.def"
#endif

    char* label;
    CharFont* font;
    int where;
} LabeldWindow;

typedef struct _ButtonWindow
{
#ifndef DEPEND
#include "anywin.def"
#endif

    char* label;
    CharFont* font;
    Bool enter_flag;
    Bool button_flag;
} ButtonWindow;

typedef struct _ARButtonWindow
{
#ifndef DEPEND
#include "anywin.def"
#endif

    char* label;
    CharFont* font;
    int count;
    double delay;
    void (* stop_arbutton_handler)(/* ARButtonWindow* */);
} ARButtonWindow;

typedef struct _IconButton
{
#ifndef DEPEND
#include "anywin.def"
#endif

    Pixmap released_pixmap;
    Pixmap pressd_pixmap;
    int pixmap_width, pixmap_height;
    Bool pressd;
    Bool reset_when_released;
    int icon_button_id;
    void (* redraw_proc)(struct _IconButton* icon_button, Bool pressd);
} IconButton;

typedef struct _TrigButton
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as IconButton */
    Pixmap released_pixmap;
    Pixmap pressd_pixmap;
    int pixmap_width, pixmap_height;
    Bool pressd;
    Bool reset_when_released;
    int icon_button_id;
    void (* redraw_proc)(struct _IconButton* icon_button, Bool pressd);

    /* new member */
    double dist;
    int bd_width;
} TrigButton;

typedef struct _HScrollbar
{
#ifndef DEPEND
#include "anywin.def"
#endif

    Pixmap pm, pm1, pm2;
    int thick, len, maxlen;	/* size of thum (by picel) */
    double pos;			/* [0, 1] */
    int top;
    int nmoves;
    void (* set_pos)(/* HScrollbar* hs, double pos */);
    double shown;
    int bd_width;
} HScrollbar;

typedef struct _NamedHScrollbar
{
#ifndef DEPEND
#include "anywin.def"
#endif

    Pixmap pm, pm1, pm2;
    int thick, len, maxlen;	/* size of thum (by picel) */
    double pos;			/* [0, 1] */
    int top;
    int nmoves;
    void (* set_pos)(/* HScrollbar* hs, double pos */);
    double shown;		/* [0, 1] */
    int bd_width;
    char bar_type;
} NamedHScrollbar;

typedef struct _SelectionData
{
    Bool selected;
    char* buffer;
    Atom targets;
    Atom copy_text;
    Atom compound_text;
} SelectionData;

typedef struct _LineText
{
#ifndef DEPEND
#include "anywin.def"
#endif

    short maxlen;
    short textlen;
    short cur;
    short start_origin;
    short show_chars;
    short start_char;
    short mark_pos;
    char char_width, char_height;
    char* text;
    char* prompt;
    CharFont* font;
    SelectionData* seldata;
    Bool focus;
    void (* key_press_handler)(struct _LineText* text, XEvent* e);
    void (* draw_cursor)(struct _LineText* text);
    void (* selection_event_handler)(struct _LineText* text, XEvent* e);
} LineText;


typedef struct _DirLineText
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as LineText */
    short maxlen;
    short textlen;
    short cur;
    short start_origin;
    short show_chars;
    short start_char;
    short mark_pos;
    char char_width, char_height;
    char* text;
    char* prompt;
    CharFont* font;
    SelectionData* seldata;
    Bool focus;
    void (* key_press_handler)(struct _LineText* text, XEvent* e);
    void (* draw_cursor)(struct _LineText* text);
    void (* selection_event_handler)(struct _LineText* text, XEvent* e);

    /* new members */
    short start;
    short end;
    short bd_width;
    short completion_failure;
    Bool (* dir_file_selector)(const char* pathname);
    struct _MCPopupMenu* short_cut_list;
    struct _MCPopupMenu* dir;
} DirLineText;

typedef struct _PopupMenuBase
{
#ifndef DEPEND
#include "anywin.def"
#endif

    short bd_width;
    short nitems;		/* number of items */
    short selected_item_index;	/* >= 0 if selected */
    short maxitem;		/* allocated number of items */
    char* title;
    char** name_list;		/* name list */
    int* idlist;		/* list of name id */
    void (** selected_proc_list)(struct _PopupMenuBase* m, char* name, int id);
    				/* list of selected procedure */
    CharFont* font;
    Cursor cs;
    Bool (* selecting_hook)(struct _PopupMenuBase *);
				/* If you want not to block event waiting,
				 * must return zero,
				 * otherwise return none zero. */
    Bool popup_flag;
} PopupMenuBase;

typedef struct _MCPopupMenu
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as PopupMenuBase */
    short bd_width;
    short nitems;		/* number of items */
    short selected_item_index;	/* >= 0 if selected */
    short maxitem;		/* allocated number of items */
    char* title;
    char** name_list;		/* name list */
    int* idlist;		/* list of name id */
    void (** selected_proc_list)(struct _PopupMenuBase* m, char* name, int id);
    				/* list of selected procedure */
    CharFont* font;
    Cursor cs;
    Bool (* selecting_hook)(struct _PopupMenuBase *);
				/* If you want not to block event waiting,
				 * must return zero,
				 * otherwise return none zero. */
    Bool popup_flag;

    /* new members */
    int title_offset;
} MCPopupMenu;

typedef struct _PopupMenu
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as PopupMenuBase */
    short bd_width;
    short nitems;		/* number of items */
    short selected_item_index;	/* >= 0 if selected */
    short maxitem;		/* allocated number of items */
    char* title;
    char** name_list;		/* name list */
    int* idlist;		/* list of name id */
    void (** selected_proc_list)(struct _PopupMenuBase* m, char* name, int id);
    				/* list of selected procedure */
    CharFont* font;
    Cursor cs;
    Bool (* selecting_hook)(struct _PopupMenuBase *);
				/* If you want not to block event waiting,
				 * must return zero,
				 * otherwise return none zero. */
    Bool popup_flag;

    /* new members */
    void (* popup_map_proc)  (union _WinObj* win_obj, int x, int y);
    void (* popup_unmap_proc)(union _WinObj* win_obj);
    void (* draw_item_proc)(union _WinObj* win_obj, int n, Bool selected_flag);
    struct _PopupMenu** hierarchical;
    struct _PopupMenu* hierarchical_target;
    char* marker;
    Pixmap popup_background;
    char item_height;
    char title_offset;
    struct _MenuBar* bar_ref;
    Bool update_flag;
    Bool* noselect;
} PopupMenu;

typedef struct _DrawerPopupMenu
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as PopupMenu */
    short bd_width;
    short nitems;		/* number of items */
    short selected_item_index;	/* >= 0 if selected */
    short maxitem;		/* allocated number of items */
    char* title;
    char** name_list;		/* name list */
    int* idlist;		/* list of name id */
    void (** selected_proc_list)(struct _PopupMenuBase* m, char* name, int id);
    				/* list of selected procedure */
    CharFont* font;
    Cursor cs;
    Bool (* selecting_hook)(struct _PopupMenuBase *);
				/* If you want not to block event waiting,
				 * must return zero,
				 * otherwise return none zero. */
    Bool popup_flag;
    void (* popup_map_proc)  (union _WinObj* win_obj, int x, int y);
    void (* popup_unmap_proc)(union _WinObj* win_obj);
    void (* draw_item_proc)(union _WinObj* win_obj, int n, Bool selected_flag);
    struct _PopupMenu** hierarchical;
    struct _PopupMenu* hierarchical_target;
    char* marker;
    Pixmap popup_background;
    char item_height;
    char title_offset;
    struct _MenuBar* bar_ref;
    Bool update_flag;
    Bool* noselect;
} DrawerPopupMenu;

typedef struct _MenuBarItem
{
    char* name;
    union _WinObj* popup;
} MenuBarItem;

typedef struct _MenuBar
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int nmenu;
    char** name_list;
    int* name_width_list;
    int* name_x_list;
    union _WinObj** popup_list;
    CharFont* font;
    int popup_menu_index;
    int bd_width;
    Bool (* switch_menu_proc)(struct _MenuBar *, XEvent* e, int* status_ret);
} MenuBar;

typedef struct _SelectMenu
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int selected_id;
    CharFont* font;
    union _WinObj* select_popup;
} SelectMenu;

typedef struct _HAdjustGear
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int cur;
    int measure;
    Pixmap pm;
    int diff;
    int r;
} HAdjustGear;
typedef HAdjustGear VAdjustGear;

typedef struct _ChoiceButton
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int bd_width;
    char* label_string;
    int n;			/* number of choices */
    char** choice_strings;
    int selected;
    Window* choice_win;
    int *width_list;
    CharFont* font;
    Bool expose_flag;
} ChoiceButton;

typedef struct _HSimpleSlider
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int bd_width;
    int pos;			/* [0, maxlen] */
    int maxlen;			/* maximum slider length by pixel */
    Bool motion_compress;	/* motion compress doing ? (default: True) */
    Pixmap tmp_pm;		/* temporary pixmap for repaint */
    Bool move_able;
    void (* key_press_handler)(union _WinObj* slider, XEvent* e);
} HSimpleSlider;

typedef struct _HLimitedSlider
{
#ifndef DEPEND
#include "anywin.def"
#endif

    /* same as HSimpleSlider */
    int bd_width;
    int pos;			/* [0, maxlen] */
    int maxlen;			/* maximum slider length by pixel */
    Bool motion_compress;	/* motion compress doing ? (default: True) */
    Pixmap tmp_pm;		/* temporary pixmap for repaint */
    Bool move_able;
    void (* key_press_handler)(union _WinObj* slider, XEvent* e);

    int limit;
} HLimitedSlider;

typedef struct _MessageDialog
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int bd_width;
    ButtonWindow* ok_button;
    char* message;
    CharFont* font;
    Bool mapped;
} MessageDialog;

typedef struct _QueryYesNo
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int bd_width;
    ButtonWindow* yes_button;
    ButtonWindow* no_button;
    char* message;
    CharFont* font;
    Bool mapped;
    void (* yes_selected)(struct _QueryYesNo* qyn);
    void (* no_selected)(struct _QueryYesNo* qyn);
} QueryYesNo;

typedef struct _GraphPanel
{
#ifndef DEPEND
#include "anywin.def"
#endif

    int* gpbuff;
    int prev_x, prev_y;
    int xresolution;
    int yresolution;
    Bool prev_flag;
    int start_x, start_y;
} GraphPanel;

typedef union _WinObj
{
    int type;
    AnyWindow any;
    BorderSkeleton border;
    SimpleWindow simpwin;
    LabeldWindow label;
    ButtonWindow button;
    ARButtonWindow arb;
    IconButton icon;
    TrigButton trig_button;
    HScrollbar hscr;
    LineText text;
    DirLineText dirtext;
    NamedHScrollbar named_hscr;
    PopupMenuBase popup_menu_base;
    PopupMenu popup_menu;
    DrawerPopupMenu drawer_popup_menu;
    MCPopupMenu mc_popup_menu;
    MenuBar menu_bar;
    SelectMenu select_menu;
    HAdjustGear ha;
    VAdjustGear va;
    ChoiceButton choice;
    HSimpleSlider sslider;
    HLimitedSlider limited_slider;
    MessageDialog msg_dialog;
    QueryYesNo qyn;
    GraphPanel gp;
} WinObj;

typedef struct _WinObjList
{
    WinObj* obj;
    struct _WinObjList* next;
} WinObjList;

WinObj* new_WinObj(void);
WinObj* new_AnyWindow(void);

WinObj* toplevel_WinObj(Display* disp,
			const char* wname,
			const char* iname,
			int width,
			int height,
			Pixel fg,
			Pixel bg);

WinObj* create_AnyWindow(WinObj* parent,
			 int x,
			 int y,
			 int width,
			 int height);

WinObj* create_SimpleWindow(WinObj* parent,
			    int x,
			    int y,
			    int width,
			    int height,
			    int bd_width,
			    int border_style);

WinObj* create_BorderSkeleton(WinObj* parent,
			      int x,
			      int y,
			      int width,
			      int height,
			      int bd_width,
			      int border_style);
void RedrawBorderSkeletion(WinObj* border);

WinObj* create_LabeldWindow(WinObj* parent,
			    int x,
			    int y,
			    int width,
			    int height,
			    int bd_width,
			    CharFont* font,
			    const char* label,
			    int border_type,
			    int where);
void SetLabeldWindowLabel(WinObj* lw,
			  const char* label,
			  int border_type);

WinObj* create_Button(WinObj* parent,
		      int x,
		      int y,
		      int width,
		      int height,
		      int bd_width,
		      CharFont* font,
		      const char* label);

WinObj* create_ARButton(WinObj* parent,
			int x,
			int y,
			int width,
			int height,
			int bd_width,
			CharFont* font,
			const char* label);

WinObj* create_IconButton(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  Pixmap pixmap1,
			  Pixmap pixmap2,
			  int pixmap_width,
			  int pixmap_height);
void SetPressdIconButton(WinObj* icon, Bool pressd);

WinObj* create_TrigButton(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  double dist);
void SetPressdTrigButton(WinObj* tb, Bool pressd);

WinObj* create_HScrollbar(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  double shown);
void SetHScrollbarThumbPos(HScrollbar* hs, double pos);
double GetHScrollbarThumbPos(HScrollbar* hs);
void SetHScrollbarShown(HScrollbar* hs, double shown);
double GetHScrollbarShown(HScrollbar* hs);

WinObj* create_NamedHScrollbar(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  double shown);
void SetNamedHScrollbarBartype(NamedHScrollbar* hs, char ch,
			       CharFont* font);

WinObj* create_PopupMenuBase(Display* disp,
			     const char* title,
			     int bd_width,
			     Pixel fg,
			     Pixel bg,
			     CharFont* font);
Bool add_PopupMenuBase(WinObj* win_obj,
		       const char* name,
		       int menu_id,
		       void (*selected_proc)
		       		(PopupMenuBase* m, char* name, int id));
Bool rename_PopupMenuBase(WinObj* menu, const char* name, int id);
void clear_PopupMenuBase(WinObj* menu);
int PopupMenuIdToIndex(WinObj* popup, int id, Bool errorp);

WinObj* create_PopupMenu(Display* disp,
			 const char* title,
			 int bd_width,
			 Pixel fg,
			 Pixel bg,
			 CharFont* font);
Bool add_PopupMenu(WinObj* menu,
		   const char* name,
		   int menu_id,
		   void (*selected_proc)
		   	(PopupMenuBase* menu, char* name, int id));
Bool rename_PopupMenu(WinObj* menu, const char* name, int id);
Bool PopupMenu_popup_proc(WinObj* menu, int x, int y);
void clear_PopupMenu(WinObj* menu);
void PopupMenuHierarchicalHook(PopupMenuBase* popup, char* name, int id);
void PopupMenuSetNextMenu(WinObj* menu, int id, WinObj* next_menu);
void PopupMenuNoselect(WinObj* menu, int id);
void PopupMenuResetNoselect(WinObj* menu, int id);
int  PopupMenuChangeMarker(WinObj* menu, int new_id);
int  PopupMenuMarkerID(WinObj* menu);

WinObj* create_MCPopupMenu(Display* disp,
			   const char* title,
			   int bd_width,
			   Pixel fg,
			   Pixel bg,
			   CharFont* font);
Bool add_MCPopupMenu(WinObj* menu,
		     const char* name,
		     int menu_id,
		     void (*selected_proc)
		     		(PopupMenuBase* menu, char* name, int id));
Bool rename_MCPopupMenu(WinObj* menu, const char* name, int id);
Bool MCPopupMenu_popup_proc(WinObj* menu, int nline);
void clear_MCPopupMenu(WinObj* menu);

WinObj* create_DrawerPopupMenu(Display* disp,
			       const char* title,
			       int bd_width,
			       Pixel fg,
			       Pixel bg,
			       CharFont* font);

WinObj* create_MenuBar(WinObj* parent,
		       int x,
		       int y,
		       int width,
		       CharFont* font,
		       int bd_width,
		       MenuBarItem* item,
		       int n,
		       char* help_string,
		       WinObj* help_popup);

WinObj* create_SelectMenu(WinObj* parent,
			  int x,
			  int y,
			  CharFont* font,
			  int bd_width,
			  WinObj* popup,
			  int selected);
void SetSelectMenuItem(WinObj* sel, int menuid);

WinObj* create_LineText(WinObj* parent,
			int x,
			int y,
			int width,
			int height,
			int bd_width,
			CharFont* font,
			const char* prompt);

Bool LineTextForwardChar(LineText* text);
Bool LineTextBackwardChar(LineText* text);
Bool LineTextDeleteChar(LineText* text);
Bool LineTextInsertChar(LineText* text, char ch);
Bool LineTextInsertWChar(LineText* text, char ch1, char ch2);
void LineTextFocusIn(LineText* text);
void LineTextFocusOut(LineText* text);
Bool LineTextKillRegion(LineText* text);
Bool LineTextKillLine(LineText* text);
void LineTextYank(LineText* text);
void SetLineText(LineText* text, char* buff, int len);
int  GetLineText(LineText* text, char* buff, int maxlen);
void LineTextRedraw(LineText* text);

WinObj* create_DirLineText(WinObj* parent,
			   int x,
			   int y,
			   int width,
			   int height,
			   int bd_width,
			   CharFont* font,
			   const char* prompt);
Bool AddDirLineTextShortCut(WinObj* text, const char* fname);
void SetDirLineTextFileSelector(WinObj* text,
				Bool (* dir_file_selector)
					(const char* pathname));
void SetPopupSelectingHook(WinObj* text,
			   Bool (* selecting_hook)(PopupMenuBase* menu));
void ClearDirLineTextCache(void);
void SetDirLineTextShortCut(DirLineText* dirtext, MCPopupMenu* menu);

WinObj* create_HAdjustGear(WinObj* parent,
			   int x,
			   int y,
			   int width,
			   int height,
			   int bd_width,
			   int measure);
WinObj* create_VAdjustGear(WinObj* parent,
			   int x,
			   int y,
			   int width,
			   int height,
			   int bd_width,
			   int measure);

WinObj* create_ChoiceButton(WinObj* parent,
			    int x,
			    int y,
			    int bd_width,
			    int button_height,
			    CharFont* font,
			    char* label_string,
			    char** choice_strings,
			    int number_of_choice_strings,
			    int default_choice_string);
void change_ChoiceButton(WinObj* c, int select_number);

WinObj* create_HSimpleSlider(WinObj* parent,
		      int x,
		      int y,
		      int width, /* len */
		      int height, /* thick */
		      int bd_width,
		      int default_pos);
void SetHSimpleSliderPos(WinObj* slider, int pos);

WinObj* create_HLimitedSlider(WinObj* parent,
		      int x,
		      int y,
		      int width, /* len */
		      int height, /* thick */
		      int bd_width,
		      int default_pos,
		      int limit);
void SetHLimitedSliderPos(WinObj* slider, int pos);
void SetHLimitedSliderLimit(WinObj* slider, int limit);

WinObj* create_MessageDialog(Display* disp,
			     int bd_width,
			     Pixel fg,
			     Pixel bg,
			     CharFont* font);
void DisplayMessageDialog(WinObj* obj, const char* msg);

WinObj* create_QueryYesNo(Display* disp,
			  int bd_width,
			  Pixel fg,
			  Pixel bg,
			  CharFont* font);
void QueryYesNoProc(WinObj* obj, const char* msg);

WinObj* create_GraphPanel(WinObj* parent,
			  int x,
			  int y,
			  int width,
			  int height,
			  int bd_width,
			  int xresolution,
			  int yresolution);
const int* GetGraphPanelValueList(WinObj* gp, int* nelem_return);

void SetCallBackProc(WinObj* obj, call_back_t proc);
void SetEventMask(WinObj* obj, unsigned long mask);
void SetEventHandler(WinObj* obj, void (* event_handler)());
void CallCallbackProc(WinObj* obj, XEvent* e);
void ResizeWinObj(WinObj* obj, int width, int height);
void MoveWinObj(WinObj* obj, int x, int y);
void DestroyWinObj(WinObj* obj);
Bool WinObjPopupAble(WinObj* obj);
void VisitEachWinObj(WinObj* root, void (* visitor)(WinObj* obj));
void WinObjRealize(WinObj* obj);
void MainLoop(void);
void DispatchEvent(XEvent* e);

/* 顼ؿ */
Bool (* WinObjSetErrorHandler(int (* handler)(int error_code, const char* error_text)))(int error_code, const char* error_text);
void CallWinObjErrorHandler(int error_code, const char* msg);
void CallWinObjSysErrorHandler(const char* msg);
extern int (* WinObjErrorHandler)(int error_code, const char* error_text);

/* ǻѡ*/
Bool install_event_handler(Display* disp, Window win, WinObj* obj);
void uninstall_event_handler(Display* disp, Window win);
Bool popupmenubase_keypress_internal_proc(PopupMenuBase* menu,
					  XEvent* e, int iw, int ih);
int popupmenubase_item_width_internal(PopupMenuBase* menu);
void unmap_popup_menu_internal(PopupMenu* menu);
void* winobj_malloc(int n);
void* winobj_realloc(void* ptr, int n);
char* winobj_strdup(const char* string);
void winobj_free(void* ptr);
double get_dispatch_table_use_ratio();
char* ExpandHomeDirectory(const char* pathname);

extern Display** all_display_list;
extern int number_of_display;
extern int sizeof_WinObj;
extern int display_visual_type;
extern char* winobj_null_string;
extern Bool locale_initialized;

#define CastWinObj(obj) ((WinObj *)(obj))
#define IsMonoDisplay(obj) (CastWinObj(obj)->any.mono_color)
#define SkeletonWinObj(obj) (CastWinObj(obj)->any.border_skeleton == NULL ? CastWinObj(obj) : CastWinObj(CastWinObj(obj)->any.border_skeleton))
#define WinObjTop(obj) (SkeletonWinObj(obj)->any.y)
#define WinObjBottom(obj) (SkeletonWinObj(obj)->any.y + SkeletonWinObj(obj)->any.height)
#define WinObjRight(obj) (SkeletonWinObj(obj)->any.x + SkeletonWinObj(obj)->any.width)
#define WinObjLeft(obj) (SkeletonWinObj(obj)->any.x)


#ifdef DEBUG
#ifdef sun
int fprintf(FILE* stream, const char* const format, ...);
int printf(const char* format, ...);
void perror(const char* s);
void usleep(unsigned long useconds);
/* FIXME
int _flsbuf(unsigned char, FILE* fp);
void bcopy(const void* b1, void* b2, int length);
 */
int puts(const char* s);
unsigned int sleep(unsigned int);
#endif
#endif

#endif /* ___WINOBJ_H_ */
