#ifndef ___COLCNV_H_
#define ___COLCNV_H_


typedef struct _rgb_t {
    double r, g, b;
} rgb_t;

enum color_type
{
    RGB_T,
    HSV_T,
    HLS_T,
    CMY_T,
    CIE_T,
    YIQ_T,
    NUMBER_OF_COLOR_TYPES
};

/******************** RGB <---> HSV ********************/
void rgb_to_hsv(
    rgb_t*			/* rgb */,
    double*     		/* h return */,
    double*			/* s return */,
    double*			/* v return */
);

void hsv_to_rgb(
    double			/* h */,
    double			/* s */,
    double			/* v */,
    rgb_t*			/* rgb_r return */
);


/******************** RGB <---> HLS ********************/
void rgb_to_hls(
    rgb_t*			/* rgb_t */,
    double*			/* h return */,
    double*			/* l return */,
    double*			/* s return */
);

void hls_to_rgb(
    double			/* h */,
    double			/* l */,
    double			/* s */,
    rgb_t*			/* rgb_t return */
);


/******************** RGB <---> CMY ********************/
void rgb_to_cmy(
    rgb_t*			/* rgb_t */,
    double*			/* c return */,
    double*			/* m return */,
    double*			/* y return */
);

void cmy_to_rgb(
    double			/* c */,
    double			/* m */,
    double			/* y */,
    rgb_t*			/* rgb_t return */
);


/******************** RGB <---> CIE ********************/
void rgb_to_cie(
    rgb_t*			/* rgb_t */,
    double*			/* x return */,
    double*			/* y return */,
    double*			/* Y return */
);

void cie_to_rgb(
    double			/* x */,
    double			/* y */,
    double			/* Y */,
    rgb_t*			/* rgb_t return */
);


/******************** RGB <---> YIQ ********************/
void rgb_to_yiq(
    rgb_t*			/* rgb_t */,
    double*			/* y return */,
    double*			/* i return */,
    double*			/* q return */
);

void yiq_to_rgb(
    double			/* y */,
    double			/* i */,
    double			/* q */,
    rgb_t*			/* rgb_t return */
);

#endif /* ___COLCNV_H_ */
