#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <unistd.h>
#include "WinObj.h"

WinObj* hs1;
WinObj* hs2;
WinObj* text;

void press(WinObj* obj, XEvent* e)
{
    printf("hello\n");
}

void press_me(WinObj* obj, XEvent* e)
{
    sleep(1);
    puts("press me!");
}

void quit()
{
    exit(0);
}

void print_text(LineText* obj, XEvent* e)
{
    char buff[BUFSIZ];

    GetLineText(obj, buff, BUFSIZ);
    printf("text = `%s'\n", buff);
}

void print_count(ARButtonWindow* arb, XEvent* e)
{
    printf("count: #%d\n", arb->count);
}


void scroll_proc(HScrollbar* hs)
{
    char buff[BUFSIZ];

    sprintf(buff, "%.2f", hs->pos);
    SetLineText((LineText *)text, buff, strlen(buff));
    if((HScrollbar *)hs1 == hs)
	SetHScrollbarThumbPos((HScrollbar *)hs2, 1.0 - hs->pos);
}

void main(int argc, char** argv)
{
    Display* disp;
    WinObj* top;
    WinObj* s;
    WinObj* b;
    WinObj* quit_button;
    WinObj* ar_button;
    Pixel fg;
    Pixel bg;
    char* bgname = "blue3";
    CharFont* font;

/*    display_visual_type = DISPLAY_VISUAL_MONO; */
    if(argc == 2)
	bgname = argv[1];

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "white");
    bg = AllocNamedColor(disp, bgname);
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 400, 400, fg, bg);

    create_SimpleWindow(top, 0, 0, 20, 40, 5, WINOBJ_BORDER_CONVEX);

    s = create_SimpleWindow(top, 10, 10, 100, 100, 3, WINOBJ_BORDER_CONCAVE);
    SetEventMask(s, ButtonPressMask);
    SetEventHandler(s, press);

    b = create_Button(top, 120, 10, 60, 30, 2, font, "PressMe");
    SetCallBackProc(b, press_me);

    ar_button = create_ARButton(top, 120, 50, 60, 30, 2, font, "?");
    SetCallBackProc(ar_button, print_count);
    ar_button->arb.delay = 0.1;

    quit_button = create_Button(top, 120, 90, 60, 30, 2, font, "Quit");
    SetCallBackProc(quit_button, quit);

    hs1 = create_HScrollbar(top, 10, 130, 380, 40, 2, 0.3);
    hs2 = create_HScrollbar(top, 5, 190, 390, 40, 2, 0.07);
    SetCallBackProc(hs1, scroll_proc);
    SetCallBackProc(hs2, scroll_proc);
    
    SetNamedHScrollbarBartype((NamedHScrollbar *)
			      create_NamedHScrollbar(top,
						     5, 250,
						     190, 40,
						     2, 0.3),
			      'X', font);

    text = create_LineText(top, 10, 300, 100, 30, 2, font, "ɤ:");
    SetCallBackProc(text, print_text);

    WinObjRealize(top);
    MainLoop();
}
