#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* qyn;

void yes_selected(QueryYesNo* qyn)
{
    puts("selected `Yes'");
}

void no_selected(QueryYesNo* qyn)
{
    puts("selected `No'");
}

void press()
{
    static int count = 0;
    static char* message_list[3] = {
	"This is test of message.",
	"Ouch",
	"WinObj !",
    };

    QueryYesNoProc(qyn, message_list[count++ % 3]);
}

void quit_proc()
{
    exit(0);
}

void main()
{
    Display* disp;
    WinObj* top;
    WinObj* quit;
    Pixel fg;
    Pixel bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 200, 400, fg, bg);
    SetEventMask(top, ButtonPressMask);
    SetEventHandler(top, press);
    qyn = create_QueryYesNo(disp, 2, fg, bg, font);
    qyn->qyn.yes_selected = yes_selected;
    qyn->qyn.no_selected = no_selected;

    quit = create_Button(top,
			 30, 30, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    WinObjRealize(top);
    MainLoop();
}
