#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit_proc()
{
    exit(0);
}

void main(int argc, char** argv)
{
    Display* disp1;
    Display* disp2;
    WinObj* top1;
    WinObj* top2;
    WinObj* quit1;
    WinObj* quit2;
    WinObj* text1;
    WinObj* text2;
    Pixel fg1, bg1;
    Pixel fg2, bg2;
    CharFont* font1;
    CharFont* font2;
    WinObj** alias1;
    WinObj** alias2;

    if(argc != 2)
    {
	fprintf(stderr, "Usage: %s host\n", argv[0]);
	exit(1);
    }

    disp1 = OpenDisplay(NULL);
    disp2 = OpenDisplay(argv[1]);

    fg1 = AllocNamedColor(disp1, "black");
    bg1 = AllocNamedColor(disp1, "gray");
    font1 = CreateCharFont(disp1, "a14", "k14");

    fg2 = AllocNamedColor(disp2, "black");
    bg2 = AllocNamedColor(disp2, "gray");
    font2 = CreateCharFont(disp2, "a14", "k14");
    top1 = toplevel_WinObj(disp1, "test", "Test", 400, 170, fg1, bg1);
    top2 = toplevel_WinObj(disp2, "test", "Test", 400, 170, fg2, bg2);
    quit1 = create_Button(top1, 10, 10, 50, 30, 2, font1, "Quit");
    quit2 = create_Button(top2, 10, 10, 50, 30, 2, font2, "Quit");
    SetCallBackProc(quit1, quit_proc);
    SetCallBackProc(quit2, quit_proc);
    text1 = create_LineText   (top1, 10, 70, 380, 30, 2, font1, "Text1:");
    text2 = create_DirLineText(top2, 10, 70, 380, 30, 2, font2, "Text2:");

    alias1 = (WinObj **)malloc(2 * sizeof(WinObj *));
    alias1[0] = text2;
    alias1[1] = NULL;
    text1->any.event_alias = alias1;

    alias2 = (WinObj **)malloc(2 * sizeof(WinObj *));
    alias2[0] = text1;
    alias2[1] = NULL;
    text2->any.event_alias = alias2;

    WinObjRealize();
    MainLoop();
}
