#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* popup;
WinObj* popup2;
WinObj* popup3;
WinObj* popup32;

void toplevel_event_handler(AnyWindow* top, XEvent* e)
{
    int x, y;

    switch(e->type)
    {
      case ButtonPress:
	QueryRootPointer(top->disp, &x, &y);
	PopupMenu_popup_proc(popup, x, y);
	break;
    }
}

void item_selected(PopupMenuBase* menu,
		   char* item_name,
		   int item_id)
{
    if(item_name == NULL)
	printf("---/%d\n", item_id);
    else
	printf("%s/%d\n", item_name, item_id);
}

void quit_proc()
{
    exit(0);
}

void main(void)
{
    Display* disp;
    WinObj* top;
    WinObj* quit;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
/*    font = CreateCharFont(disp, "a14", "k14"); */
    font = CreateCharFont(disp, "r24", "kanji24");

    top = toplevel_WinObj(disp, "test", "Test", 100, 200, fg, bg);
    SetEventMask(top, ExposureMask | ButtonPressMask | PointerMotionMask);
    SetEventHandler(top, toplevel_event_handler);

    quit = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    popup = create_PopupMenu(disp, "X", 2, fg, bg, font);
    popup2 = create_PopupMenu(disp, "2", 2, fg, bg, font);
    popup3 = create_PopupMenu(disp, "3", 2, fg, bg, font);
    popup32 = create_PopupMenu(disp, "32", 2, fg, bg, font);

    add_PopupMenu(popup, "1", 1, item_selected);
    add_PopupMenu(popup, "2", 2, PopupMenuHierarchicalHook);
    add_PopupMenu(popup, "3", 3, item_selected);


    add_PopupMenu(popup2, "2.1", 1, item_selected);
    add_PopupMenu(popup2, "2.2", 2, item_selected);
    add_PopupMenu(popup2, "2.3", 3, item_selected);

    PopupMenuNoselect(popup2, 2);

    add_PopupMenu(popup3, "3.1", 1, item_selected);
    add_PopupMenu(popup3, "3.2", 2, item_selected);
    add_PopupMenu(popup3, "3.3", 3, item_selected);
    add_PopupMenu(popup3, "3.4", 4, item_selected);
    add_PopupMenu(popup3, "3.5", 5, item_selected);

    add_PopupMenu(popup32, "3-2.1", 1, item_selected);
    add_PopupMenu(popup32, "3-2.2", 2, item_selected);
    add_PopupMenu(popup32, NULL, 3, item_selected);
    add_PopupMenu(popup32, "3-2.4", 4, item_selected);

    PopupMenuSetNextMenu(popup, 2, popup2);
    PopupMenuSetNextMenu(popup, 3, popup3);
    PopupMenuSetNextMenu(popup3, 3, popup32);

    popup->popup_menu.marker[0] = True;
    popup3->popup_menu.marker[1] = True;
    popup3->popup_menu.marker[2] = True;
    popup3->popup_menu.marker[3] = True;

    WinObjRealize(top);
    MainLoop();
}
