#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* popup1;
WinObj* popup2;
WinObj* popup3;

void item_quit_selected()
{
    exit(0);
}

void item_selected(PopupMenuBase* menu,
		   char* item_name,
		   int item_id)
{
    if(item_name == NULL)
	printf("---/%d\n", item_id);
    else
	printf("%s/%d\n", item_name, item_id);
}

void quit_proc()
{
    exit(0);
}

void main(void)
{
    Display* disp;
    WinObj* top;
    WinObj* bar;
    Pixel fg, bg;
    CharFont* font;
    MenuBarItem baritem[3];

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 400, 100, fg, bg);

    popup1 = create_PopupMenu(disp, "", 6, fg, bg, font);
    popup2 = create_PopupMenu(disp, "", 2, fg, bg, font);
    popup3 = create_DrawerPopupMenu(disp, "", 2, fg, bg, font);

    add_PopupMenu(popup1, ".1", 1, item_selected);
    add_PopupMenu(popup1, ".2", 2, PopupMenuHierarchicalHook);
    add_PopupMenu(popup1, ".3", 3, item_selected);
    add_PopupMenu(popup1, "λ", 4, item_quit_selected);


    add_PopupMenu(popup2, ".1", 1, item_selected);
    add_PopupMenu(popup2, ".2", 2, item_selected);
    add_PopupMenu(popup2, ".3", 3, item_selected);

    add_PopupMenu(popup3, ".1", 1, item_selected);
    add_PopupMenu(popup3, ".2", 2, item_selected);
    add_PopupMenu(popup3, ".3", 3, item_selected);
    add_PopupMenu(popup3, ".4", 4, item_selected);
    add_PopupMenu(popup3, ".5", 5, item_selected);


    PopupMenuSetNextMenu(popup1, 2, popup2);

    baritem[0].name = "֤פǤ";
    baritem[0].popup = popup1;

    baritem[1].name = "֤פǤ";
    baritem[1].popup = popup2;

    baritem[2].name = "֤פǤ";
    baritem[2].popup = popup3;

    bar = create_MenuBar(top, 0, 0, 0, font, 2, baritem, 3, "", popup3);

    WinObjRealize(top);
    MainLoop();
}
