#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void item_selected(PopupMenuBase* menu,
		   char* item_name,
		   int item_id)
{
    if(item_name == NULL)
	printf("---/%d\n", item_id);
    else
	printf("%s/%d\n", item_name, item_id);
}

void quit_proc()
{
    exit(0);
}

void main(void)
{
    Display* disp;
    WinObj* top;
    WinObj* quit;
    WinObj* sel;
    Pixel fg, bg;
    CharFont* font;
    WinObj* popup;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 130, 200, fg, bg);

    quit = create_Button(top, 20, 30, 60, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    popup = create_PopupMenu(disp, NULL, 2, fg, bg, font);

    add_PopupMenu(popup, "Ǥ", 1, item_selected);
    add_PopupMenu(popup, "Ǥ", 2, item_selected);
    add_PopupMenu(popup, "Ǥ", 3, item_selected);

    sel = create_SelectMenu(top, 20, 100, font, 2, popup, 1);

    WinObjRealize(top);
    MainLoop();
}
