#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* limited_slider;

void slider_proc(HSimpleSlider* slider, XEvent* e)
{
    int pos = slider->pos;
    SetHLimitedSliderLimit(limited_slider, pos);
}

void slider_proc_test(HLimitedSlider* slider, XEvent* e)
{
    if(e->type == ButtonRelease)
    {
	SetHLimitedSliderPos((WinObj *)slider, slider->pos);
	puts("ButtonRelease");
    }
}

void quit()
{
    exit(0);
}

void main(void)
{
    WinObj* top;
    WinObj* slider;
    WinObj* quit_button;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "r14");

    top = toplevel_WinObj(disp, "test", "Test", 320, 200, fg, bg);

    quit_button = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit_button, quit);

    slider = create_HSimpleSlider(top,
				  WinObjLeft(quit_button),
				  WinObjBottom(quit_button) + 20,
				  300, 30, 2, 30);
    SetCallBackProc(slider, slider_proc);

    limited_slider = create_HLimitedSlider(top,
					   WinObjLeft(slider),
					   WinObjBottom(slider) + 20,
					   300, 30, 2, 30,
					   slider->sslider.pos);
    SetCallBackProc(limited_slider, slider_proc_test);

    WinObjRealize(top);
    MainLoop();
}
