#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

Bool pressd_flag = False;

void icon_proc(WinObj* icon, XEvent* e)
{
    if(e->type == ButtonRelease)
    {
	pressd_flag = !pressd_flag;
	if(pressd_flag == False)
	    SetPressdIconButton(icon, False);
    }
}

void quit()
{
    exit(0);
}

void main(void)
{
    WinObj* top;
    WinObj* icon;
    WinObj* quit_button;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "r14");

    top = toplevel_WinObj(disp, "test", "Test", 80, 100, fg, bg);

    quit_button = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit_button, quit);

    icon = create_IconButton(top,
			     WinObjLeft(quit_button),
			     WinObjBottom(quit_button) + 20,
			     10, 10, 2, None, None, 0, 0);
    SetCallBackProc(icon, icon_proc);

    WinObjRealize(top);
    MainLoop();
}
