#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit_proc()
{
    exit(0);
}

void tb_proc(WinObj* tb, XEvent* e)
{
    switch(e->type)
    {
      case ButtonPress:
	printf("[%d] press\n", tb->trig_button.icon_button_id);
	break;
      case ButtonRelease:
	printf("[%d] release\n", tb->trig_button.icon_button_id);
	break;
    }
}

void main(void)
{
    Display* disp;
    WinObj* top;
    WinObj* quit_button;
    Pixel fg;
    Pixel bg;
    int i, x, y;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 200, 200, fg, bg);
    quit_button = create_Button(top, 74, 74, 50, 50, 2, font, "Quit");
    SetCallBackProc(quit_button, quit_proc);

    for(i = 0, y = -1; y <= 1; y++)
	for(x = -1; x <= 1; x++, i++)
	{
	    double dist;
	    WinObj* tb;

	    if(!(x | y))
		continue;

	    dist = atan2((double)-y, (double)x);
	    tb = create_TrigButton(top, 100 + x * 50 - 15, 100 + y * 50 - 15,
				   30, 30, 1, dist);
	    tb->trig_button.icon_button_id = i;
	    SetCallBackProc(tb, tb_proc);
	}
    WinObjRealize(top);
    MainLoop();
}
