#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit()
{
    exit(0);
}

void enter_key(LineText* text, XEvent* e)
{
    char buff[BUFSIZ];

    GetLineText(text, buff, BUFSIZ);
    printf("Selected filename: %s\n", buff);
}

void main(void)
{
    WinObj* top;
    WinObj* btn;
    WinObj* text;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 800, 300,
                          fg, bg);

    btn = create_Button(top, 30, 30, 80, 30, 2, font, "Quit");
    SetCallBackProc(btn, quit);

    text = create_DirLineText(top, 30, 90, 700, 30, 2, font, "File:");
    SetCallBackProc(text, enter_key);

    WinObjRealize(top);
    MainLoop();
}
