#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit()
{
    exit(0);
}

void adjustment(HAdjustGear* ha, XEvent* e)
{
}

void main(void)
{
    WinObj* top;
    WinObj* btn;
    WinObj* ha;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "white");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 800, 300,
                          fg, bg);

    btn = create_Button(top, 30, 30, 80, 30, 2, font, "Quit");
    SetCallBackProc(btn, quit);

    ha = create_HAdjustGear(top, 30, 90, 500, 30, 2, 20);
    SetCallBackProc(ha, adjustment);

    {
	int i, x, y;
	y = SkeletonWinObj(ha)->any.y + SkeletonWinObj(ha)->any.height;
	x = SkeletonWinObj(ha)->any.x;
	for(i = 0; i < 6; i++)
	{
	    WinObj* gear =
		create_VAdjustGear(top, x, y, 20, 50, 2, 5);
	    x = SkeletonWinObj(gear)->any.x + SkeletonWinObj(gear)->any.width;
	}
    }

    WinObjRealize(top);
    MainLoop();
}
