#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void quit()
{
    exit(0);
}

static void choice(ChoiceButton* c, XEvent* e)
{
    printf("Selected -> %s(%s)\n", c->label_string, c->choice_strings[c->selected]);
}

void main(void)
{
    WinObj* top;
    WinObj* btn;
    WinObj* c;
    WinObj* c2;
    Display* disp;
    Pixel fg, bg;
    char* choice_strings[2] = {"ON", "OFF"};
    char* choice_strings2[3] = {"Apple", "", "Lemon"};
    CharFont* font;

/* display_visual_type = 1; */

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 800, 300, fg, bg);

    btn = create_Button(top, 30, 30, 80, 30, 2, font, "Quit");
    SetCallBackProc(btn, quit);

    c = create_ChoiceButton(top,
			    10, 
			    200,
			    2,
			    30,
			    font,
			    "test:",
			    choice_strings,
			    sizeof(choice_strings) / sizeof(char *),
			    0);

    c2 = create_ChoiceButton(top,
			     10, 
			     240,
			     2,
			     30,
			     font,
			     "test2:",
			     choice_strings2,
			     sizeof(choice_strings2) / sizeof(char *),
			     2);

    SetCallBackProc(c, choice);
    SetCallBackProc(c2, choice);

    WinObjRealize(top);
    MainLoop();
}
