#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

void slider_proc(HSimpleSlider* slider, XEvent* e)
{
    switch(e->type)
    {
      case ButtonPress:
	printf("Press: ");
	break;
      case MotionNotify:
	printf("Motion: ");
	break;
      case ButtonRelease:
	printf("Release: ");
	break;
    }

    printf("%d (%.1f %%)\n", slider->pos, 100 * ((double)slider->pos/slider->maxlen));
}

void quit()
{
    exit(0);
}

void main(void)
{
    WinObj* top;
    WinObj* slider;
    WinObj* quit_button;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "r14");

    top = toplevel_WinObj(disp, "test", "Test", 320, 90, fg, bg);
    slider = create_HSimpleSlider(top, 10, 10, 300, 30, 2, 30);
    SetCallBackProc(slider, slider_proc);

    quit_button = create_Button(top, 10, 50, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit_button, quit);

    WinObjRealize(top);
    MainLoop();
}
