#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* popup;

void apr_selected()
{
    puts("APR");
}

void button_press()
{
    if(MCPopupMenu_popup_proc(popup, 4))
    {
	if(popup->mc_popup_menu.selected_item_index == 3)
	    MCPopupMenu_popup_proc(popup, 1);
    }
}

void quit_proc()
{
    exit(0);
}

void main(void)
{
    WinObj* top;
    WinObj* quit;
    Display* disp;
    Pixel fg, bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "white");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "a14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 800, 300,
                          fg, bg);
    popup = create_MCPopupMenu(disp, "X", 5, fg, bg, font);
    SetEventMask(top, ButtonPressMask);
    SetEventHandler(top, button_press);

    quit = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    add_MCPopupMenu(popup, "Jan", 0, NULL);
    add_MCPopupMenu(popup, "Feb", 1, NULL);
    add_MCPopupMenu(popup, "Mar", 2, NULL);
    add_MCPopupMenu(popup, "4", 3, apr_selected);

    WinObjRealize(top);
    MainLoop();
}
