#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "WinObj.h"

WinObj* gp;

#ifdef DEBUG
int atoi(const char *);
#endif


void quit_proc()
{
    exit(0);
}

void change_resolution(ChoiceButton* c, XEvent* e)
{
    gp->gp.xresolution = atoi(c->choice_strings[c->selected]);
}

void main()
{
    Display* disp;
    WinObj* top;
    WinObj* quit;
    WinObj* res_choice;
#define NCHOICE 7
    char *res_choice_names[NCHOICE] = {"1", "2", "4", "8", "16", "32", "64"};

    Pixel fg;
    Pixel bg;
    CharFont* font;

    disp = OpenDisplay(NULL);
    fg = AllocNamedColor(disp, "black");
    bg = AllocNamedColor(disp, "gray");
    font = CreateCharFont(disp, "r14", "k14");

    top = toplevel_WinObj(disp, "test", "Test", 400, 240, fg, bg);

    quit = create_Button(top, 10, 10, 50, 30, 2, font, "Quit");
    SetCallBackProc(quit, quit_proc);

    gp = create_GraphPanel(top, 10, 50, 380, 140, 2, 2, 30);

    res_choice = create_ChoiceButton(top, 10, 200,
				     2, 30, 
				     font, "Resolution: ",
				     res_choice_names, NCHOICE,
				     1);
    SetCallBackProc(res_choice, change_resolution);

    WinObjRealize(top);
    MainLoop();
}
