#ifndef ___AUBUFF_H_
#define ___AUBUFF_H_

/* aubuff  Audio Խ뤿βХåե󶡤ޤ
 * AudioBuffer ΥǡμΤ signed 16-bit linear PCM Ǥ
 */

#include "usffd.h"

typedef struct _AudioBuffer
{
    char* name;			/* ˡǤХåե̾ */
    char* filename;		/* ХåեбƤե̾ */

    short** buffer;		/* Хåեμ (signed 16-bit linear PCM)
				 * buffer[n-1] ϥͥ n б*/
    long nsamples;		/* ץ */
    long nchannels;		/* ͥ */
    long sample_rate;		/* եץ졼 */
    long file_encoding;		/* ȤΥե粽 */
    int  hdr_type;		/* ȤΥեΥإå */
    Bool record_flag;		/* ϿΥХåեʤ True */
    long alloc_samples;		/* ݤƤ */

    /* ʲϥХåե򿷤ꡤ뤿Υ */
    Bool mark;			/* ԲǽʥХåեõ٤Υޡ */
    struct _AudioBuffer* next;	/* ¾ΥХåեؤΥꥹ */
#if 0
    long allocated_s;		/* ݤץ */
    long allocated_c;		/* ݤͥ */
#endif
} AudioBuffer;

void initialize_audio_buffer(void);
/* ǽ 1 ٤ƤӽФޤ
 */

AudioBuffer* make_new_audio_buffer(const char* name);
/* ХåեޤǤʤä NULL ֤ޤ
 */

AudioBuffer* get_audio_buffer(const char* name);
/* name бХåե֤ޤname ¸ߤʤ NULL 
 * ֤ޤ
 */

void erase_audio_buffer(AudioBuffer* buf);
/* buf ˤޤ
 * Хåե̾ե̾ϤΤޤޤǡȤΥǡΤߤõޤ
 * buffer  NULL ˡnsamples  0 ˤʤޤʳѹޤ
 */

void kill_audio_buffer(AudioBuffer* buf);
/* buf ˾õޤ
 * δؿθƤӽФ塤buf ΥФ˥ƤϤʤޤ
 */

AudioBuffer* make_usffd_audio_buffer(const USFFD* usffd, const char* name);
/* usffd ǻꤵ줿ǡɤ߹٤οХåեޤ
 * Ԥ NULL ֤ޤ
 */

void clear_audio_buffer_mark(void);
/*  AudioBuffer  mark  False ˥ꥻåȤޤ*/

void audio_buffer_garbage_collect(void);
/* AudioBuffer  mark  False ǤХåեޤ*/

Bool audio_buffer_cut_region(AudioBuffer* aubuff, long start, long end);
/* aubuff  start  end ޤǤΥǡ AUDIO_COPY_BUFF_NAME 
 * ưޤAUDIO_COPY_BUFF_NAME ˤäƤϾõޤ
 *  True 򡢼Ԥ False ֤ޤ
 */

Bool audio_buffer_copy_region(AudioBuffer* aubuff, long start, long end);
/* aubuff  start  end ޤǤΥǡ AUDIO_COPY_BUFF_NAME 
 * ԡޤAUDIO_COPY_BUFF_NAME ˤäƤϾõޤ
 *  True 򡢼Ԥ False ֤ޤ
 */

Bool audio_buffer_delete_region(AudioBuffer* aubuff,
				long start, long end);
/* aubuff  start  end ޤǤΥǡõޤ
 *  True 򡢼Ԥ False ֤ޤ
 */

Bool audio_buffer_make_buffer(AudioBuffer* b, long nsamples, int nchannels);
/* Хåե b Υǡΰnchannels  nsamples ݤޤ
 *  True 򡢼Ԥ False ֤ޤ
 */

Bool convert_audio_format(AudioBuffer* from_buff, /* no modified */
			  AudioBuffer* to_buff,	  /* erase the original */
			  long start, long end,
			  long nchannels, long sample_rate);
/* from_buff Υǡ nchannels, sample_rate Ѵơ
 * Υǡto_buff ¸ޤto_buff ΰƤϾõޤ
 *  True 򡢼Ԥ False ֤ޤ
 */

long insert_audio_buffer(AudioBuffer* from_buff,
			 AudioBuffer* to_buff,
			 long to_pos);
/* from_buff Ƥto_buff ΰ to_pos ޤ
 * from_buff  to_buff Υͥȥץ졼Ȥۤʤ硢
 * ǡѴ뤿ˡAUDIO_TEMP_BUFF_NAME Ѥޤ
 * ξ硢AUDIO_TEMP_BUFF_NAME ΰƤϾõޤ
 *  줿ץ 򡢼Ԥ -1 ֤ޤ
 */

Bool merge_audio_buffer(AudioBuffer* from_buff,
			AudioBuffer* to_buff,
			long to_pos);
Bool overwrite_audio_buffer(AudioBuffer* from_buff,
			    AudioBuffer* to_buff,
			    long to_pos);

Bool is_audio_buffer_empty(AudioBuffer* buff);
/* buff ʤ TrueǤʤʤ False
 *
 * COMMENT:
 * δؿϸ夫ĤäɡʤȤǻȤʤΤǡ
 * ǻȤȤõơ񤭴Ƥ͡
 */


/* ǽΥǥեȤΥХåե (Emacs  scratch ˤ) */
#define AUDIO_DEFAULT_BUFF_NAME "*Audio Default Buffer*"

/* ʲΥڡϤޤХåե̾ΥХåեϡ
 * 桼˸ʤХåեǤ롣
 * ٺȺ뤳ȤϤʤ
 */
/* Cut & Paste ѤѥХåե */
#define AUDIO_COPY_BUFF_NAME " *Copy Buffer*"

/* ǡѴѥХåե */
#define AUDIO_TEMP_BUFF_NAME " *Temporary*"

#endif /* ___AUBUFF_H_ */
