#include <stdio.h>

typedef unsigned int ulong32;

typedef struct _Audio_filehdr
{
    ulong32 magic;
    ulong32 hdr_size;
    ulong32 data_size;
    ulong32 data_encoding;
    ulong32 sample_rate;
    ulong32 nchannels;
} Audio_filehdr;

/* for Audio_filehdr encoding */
#define	AUDIO_FILE_MAGIC		((unsigned long)0x2e736e64)
#define	AUDIO_FILE_ENCODING_MULAW_8	1	/* 8-bit ISDN u-law */
#define AUDIO_FILE_ENCODING_ALAW_8	27 	/* 8-bit ISDN A-law */
#define	AUDIO_FILE_ENCODING_LINEAR_8	2	/* 8-bit linear PCM */
#define	AUDIO_FILE_ENCODING_LINEAR_16	3	/* 16-bit linear PCM */
#define AUDIO_FILE_ENCODING_UNSIGNED_LINEAR_8 1000 /* unsigned 8-bit linear PCM */

#define SWAP_ENDIAN4(x) ((((ulong32)(x)) >> 24) | ((((ulong32)(x)) >> 8) & 0xff00) | ((((ulong32)(x)) << 8) & 0xff0000) | (((ulong32)(x)) << 24))

static long read_long_bigend(int fd)
{
    ulong32 x;

    read(fd, &x, sizeof(ulong32));
#ifdef BIGENDIAN
    return (long)x;
#else
    return (long)SWAP_ENDIAN4(x);
#endif
}

static int read_file_header(const char* filename, Audio_filehdr* hdr)
{
    hdr->magic = read_long_bigend(fd);
    hdr->hdr_size = read_long_bigend(fd);
    hdr->data_size = read_long_bigend(fd);
    hdr->data_encoding = read_long_bigend(fd);
    hdr->sample_rate = read_long_bigend(fd);
    hdr->nchannels = read_long_bigend(fd);
}



void main(int argc, char** argv)
{
