#ifndef ___PLAYER_H_
#define ___PLAYER_H_

enum ff_rw_type_t
{
    FF_RW_UNUSED,
    FAST_FORWARD_PLAY,
    FAST_REWIND_PLAY
};

#define FAST_FORWARD_STEP1 2
#define FAST_REWIND_STEP1 2
#define FAST_MAX_STEP 128
#define FFRW_SWITCH_SEC 3

typedef struct _AudioPlayer
{
    struct _AudioBuffer* aubuff; /* ߤ scope ɽƤ Audio 
				 * ХåեǤդ Audio ˴ؤ
				 * Ϥι¤Τˤޤ
				 */
    long pos;			/* ճϰ (ץ) */
    long region_start, region_end; /* ΰ (ץ) */
    Bool looping;		/* True ʤ ֤ */

    Bool load_flag;		/* Хåե˿ǡɤ߹ */
    struct _AudioBucketFilter* bucket_reader[MAX_BUCKET_NCHANNELS];

    /* եܥ */
    WinObj* stop_and_rewind_button;
    WinObj* fast_rewind_button;
    WinObj* fast_forward_button;
    WinObj* play_button;
    WinObj* stop_button;
    enum ff_rw_type_t ff_rw_type;
    Bool is_ff_rw_stop_flag;	/* True ʤ ()νλ
				 * player  stop ޤ
				 */
    Bool play_flag;		/* True ʤǤ */

    long sample_rate;		/* ջΥץ졼 */
    Bool custom_sample_rate;	/* True ʤ ॵץ졼 */

    struct _SSFrame* frame_reference;
    WinObj* looping_button;
    long pos_offset;		/* ǥХήޤ줿ץ
				 * ߤαհ֤׻뤿͡
				 */
    int ffre_step;
    double start_ffre_time;
} AudioPlayer;


void audio_player_initialize(AudioPlayer* player, struct _SSFrame* frame);
/* player ޤ*/

void player_get_region(AudioPlayer* player, long* pos_min, long* pos_max);
/* player αΰޤ
 * ͤϥץñ̤Ǥ
 */

long calc_player_samples(AudioPlayer* player, long samples);
/* player αհ֤򻻽Фޤ*/

void set_initial_player(AudioPlayer* player);
/* player վ֤ꤷޤ
 * ǤСߤޤեܥϸξ֤ޤ
 * պƳ֤Ϻǽꤵޤ
 * ΰϲޤ
 */

Bool audio_player_check_finish(AudioPlayer* player, long sample);
/* player αդλƤ True ֤Ǥʤ False 
 * ֤ޤ
 */

void player_change_sample_rate(AudioPlayer* player, long sample_rate);
/* player αեץ졼Ȥꤷޤ
 * sample_rate  1000  99999 ޤǤͤǤʤƤϤʤޤ
 * ǥХΥݡȤƤʤ sample_rate ꤵƤ⡤
 * soundscope ϡŬѴʤ顤ꤵ줿ץ졼ȤǱդޤ
 */

void player_change_output(long output);
/* ꤷޤ
 */

void player_change_encoding(long encoding);
/* ջ粽ꤷޤ
 */

void player_change_channel(long channel);
/* ջΥͥꤷޤ
 */

Bool player_start_play(AudioPlayer* player);
/* player αդ򳫻Ϥޤճϰ֤ player->pos ˤʤޤ
 * player ǤϤʤˤ⤷ޤ
 */

void player_stop_play(AudioPlayer* player);
/* player αդߤޤ֤߰ player->pos ˵Ͽޤ
 */

void player_stop_and_rewind(AudioPlayer* player);
/* player αդߤޤ߸塤ճϰ֤ 0 ˤʤޤ
 * player Ǥʤϱճϰ֤ 0 ꤵΤߤȤʤޤ
 */

void player_start_fast_forward_play(AudioPlayer* player, int step);
void player_stop_fast_forward_play(AudioPlayer* player);
/* 򳫻(λ)ޤ
 */

void player_start_fast_rewind_play(AudioPlayer* player, int step);
void player_stop_fast_rewind_play(AudioPlayer* player);
/* պ򳫻(λ)ޤ
 */



extern long device_nchannels;
extern long device_sample_rate;
extern long device_data_encoding;
extern enum ff_rw_type_t forward_backward_button_mode;


#define AUDIO_PLAYER_REGIONP(player) ((player)->region_start < (player)->region_end)
#define AUDIO_PLAYER_POS_MIN(player) (AUDIO_PLAYER_REGIONP(player) ? (player)->region_start : 0)
#define AUDIO_PLAYER_POS_MAX(player) (AUDIO_PLAYER_REGIONP(player) ? (player)->region_end : (player)->aubuff->nsamples)

#endif /* ___PLAYER_H_ */
