#include <stdio.h>
#include <math.h>
#include "soundscope.h"
#include "ssframe.h"
#include "player.h"
#include "aubuff.h"

#define FFT_SCALE 0.30

void init_scope_spectram(SSFrame* frame)
{
  /* do nothing */
}

void draw_scope_spectram(SSFrame* frame, int ch, long sample)
{
    int x, y, width, height;
    int i, j;
    double wr, hr;
    double t, u, p;
    double yz;

    yz = frame->yzoom;
    get_current_fft_data(frame, ch, sample);
    get_scope_draw_region(frame, ch, &x, &y, &width, &height);

    hr = (0.96 * FFT_SCALE) * height * yz;
    if(fft_data[0] >= 0)
	p = fft_data[0];
    else
	p = -fft_data[0];
    p = log(1.0 + (128.0 / FFTSIZE) * p);
    wave_points[0].y = y + height - 1 - (int)(hr * p);

    for(i = 1, j = FFTSIZE - 1; i < FFTSIZE/2; i++, j--)
    {
	int ty;

	t = fft_data[i];
	u = fft_data[j];
	p = log(1.0 + (128.0 / FFTSIZE) * sqrt(t*t + u*u));

	ty = (int)(hr * p);
	if(ty > height)
	    ty = height;
	wave_points[i].y = y + height - 1 - ty;
    }

    if(frame->local_mode_selector[SCOPE_HZ_LOG]->choice.selected == 1)
    {
	wr = (double)width / (double)(FFTSIZE/2 + 1);
	for(i = 0; i < FFTSIZE/2; i++)
	    wave_points[i].x = x + (int)(wr * i);
    }
    else
    {
	double x1, x2;
	double tx1, tx2;
	double x_start = 1.0;

	x1 = x_start;
	x2 = x1 + LOG_HZ_MAX_X1 - frame->zoom[SCOPE_SPECTORAM] + LOG_HZ_MIN_X1;
	tx1 = log(x1);
	tx2 = log(x2);
	wr = (double)width;
	for(i = 0; i < FFTSIZE/2; i++)
	    wave_points[i].x = x + (int)(wr * frame->log_hz_table[i]);
    }
    XSetForeground(disp, gc, scope_fg);
    XDrawLines(disp, frame->scope_pm, gc, wave_points, FFTSIZE/2,
	       CoordModeOrigin);
    for(i = 0; i < FFTSIZE/2; i++)
    {
	short y;
	y = wave_points[i].y;
	if(y < repaint_y_min)
	    repaint_y_min = y;
    }

    if(frame->local_mode_selector[SCOPE_WAVEFORM]->choice.selected == 1)
	draw_scope_wave(frame, ch, sample);
}
