/* soundex - sound format exchanger library */

#ifndef ___SOUNDEX_H_
#define ___SOUNDEX_H_

/* FIXME SOUNDEX_INTERVAL_SIZE - unused this macro in any where */
#define SOUNDEX_INTERVAL_SIZE (1024*8)

#ifndef CHAR_PTR 
#define CHAR_PTR void*
#endif

#ifndef UNSIGNED_CHAR_PTR
#define UNSIGNED_CHAR_PTR void*
#endif

#ifndef SHORT_PTR
#define SHORT_PTR void*
#endif

#ifndef UNSIGNED_SHORT_PTR
#define UNSIGNED_SHORT_PTR void*
#endif

#ifndef CONST_CHAR_PTR 
#define CONST_CHAR_PTR void*
#endif

#ifndef CONST_UNSIGNED_CHAR_PTR
#define CONST_UNSIGNED_CHAR_PTR void*
#endif

#ifndef CONST_SHORT_PTR
#define CONST_SHORT_PTR void*
#endif

#ifndef CONST_UNSIGNED_SHORT_PTR
#define CONST_UNSIGNED_SHORT_PTR void*
#endif


/* ̾:
sig1	դ1Х			USFFD_SIGBYTE
unsig1	ʤ1Х			USFFD_UNSIGBYTE
ulaw	ˡ§				USFFD_G711_ULAW
alaw	ˡ§				USFFD_G711_ALAW
sig2b	դ2Х(big-endian)	USFFD_SIGWORDB
unsig2b	ʤ2Х(big-endian)	USFFD_UNSIGWORDB
sig2l	դ2Х(little-endian)	USFFD_SIGWORDL
unsig2l	ʤ2Х(little-endian)	USFFD_UNSIGWORDL
*/

/* ʲ nbytes  Ѵ source ΥХȿ */

/* դ1Х		  => դ1Х */
void sig1_to_sig1(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ʤ1Х		  => դ1Х */
void unsig1_to_sig1(CONST_UNSIGNED_CHAR_PTR source,
		       CHAR_PTR		       target,
		       int		       nbytes);

/* ˡ§			  => դ1Х */
void ulaw_to_sig1(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ˡ§			  => դ1Х */
void alaw_to_sig1(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* դ2Х(big-endian)	  => դ1Х */
void sig2b_to_sig1(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(big-endian)	  => դ1Х */
void unsig2b_to_sig1(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ2Х(little-endian) => դ1Х */
void sig2l_to_sig1(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(little-endian) => դ1Х */
void unsig2l_to_sig1(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ1Х		  => ʤ1Х */
void sig1_to_unsig1(CONST_CHAR_PTR    source,
		    UNSIGNED_CHAR_PTR target,
		    int		      nbytes);

/* ʤ1Х		  => ʤ1Х */
void unsig1_to_unsig1(CONST_UNSIGNED_CHAR_PTR source,
		      UNSIGNED_CHAR_PTR	      target,
		      int		      nbytes);

/* ˡ§			  => ʤ1Х */
void ulaw_to_unsig1(CONST_CHAR_PTR    source,
		    UNSIGNED_CHAR_PTR target,
		    int		      nbytes);

/* ˡ§			  => ʤ1Х */
void alaw_to_unsig1(CONST_CHAR_PTR     source,
		    UNSIGNED_CHAR_PTR target,
		    int		       nbytes);

/* դ2Х(big-endian)	  => ʤ1Х */
void sig2b_to_unsig1(CONST_SHORT_PTR   source,
		     UNSIGNED_CHAR_PTR target,
		     int	       nbytes);

/* ʤ2Х(big-endian)	  => ʤ1Х */
void unsig2b_to_unsig1(CONST_UNSIGNED_SHORT_PTR source,
		       UNSIGNED_CHAR_PTR	target,
		       int			nbytes);

/* դ2Х(little-endian) => ʤ1Х */
void sig2l_to_unsig1(CONST_SHORT_PTR   source,
		     UNSIGNED_CHAR_PTR target,
		     int	       nbytes);

/* ʤ2Х(little-endian) => ʤ1Х */
void unsig2l_to_unsig1(CONST_UNSIGNED_SHORT_PTR source,
		       UNSIGNED_CHAR_PTR	target,
		       int			nbytes);

/* դ1Х		  => ˡ§ */
void sig1_to_ulaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ʤ1Х		  => ˡ§ */
void unsig1_to_ulaw(CONST_UNSIGNED_CHAR_PTR source,
		       CHAR_PTR		       target,
		       int		       nbytes);

/* ˡ§			  => ˡ§ */
void ulaw_to_ulaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ˡ§			  => ˡ§ */
void alaw_to_ulaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* դ2Х(big-endian)	  => ˡ§ */
void sig2b_to_ulaw(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(big-endian)	  => ˡ§ */
void unsig2b_to_ulaw(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ2Х(little-endian) => ˡ§ */
void sig2l_to_ulaw(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(little-endian) => ˡ§ */
void unsig2l_to_ulaw(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ1Х		  => ˡ§ */
void sig1_to_alaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ʤ1Х		  => ˡ§ */
void unsig1_to_alaw(CONST_UNSIGNED_CHAR_PTR source,
		       CHAR_PTR		       target,
		       int		       nbytes);

/* ˡ§			  => ˡ§ */
void ulaw_to_alaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* ˡ§			  => ˡ§ */
void alaw_to_alaw(CONST_CHAR_PTR source,
		  CHAR_PTR	 target,
		  int		 nbytes);

/* դ2Х(big-endian)	  => ˡ§ */
void sig2b_to_alaw(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(big-endian)	  => ˡ§ */
void unsig2b_to_alaw(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ2Х(little-endian) => ˡ§ */
void sig2l_to_alaw(CONST_SHORT_PTR source,
		   CHAR_PTR	   target,
		   int		   nbytes);

/* ʤ2Х(little-endian) => ˡ§ */
void unsig2l_to_alaw(CONST_UNSIGNED_SHORT_PTR source,
		     CHAR_PTR		      target,
		     int		      nbytes);

/* դ1Х		  => դ2Х(big-endian) */
void sig1_to_sig2b(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* ʤ1Х		  => դ2Х(big-endian) */
void unsig1_to_sig2b(CONST_UNSIGNED_CHAR_PTR source,
		     SHORT_PTR		     target,
		     int		     nbytes);

/* ˡ§			  => դ2Х(big-endian) */
void ulaw_to_sig2b(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* ˡ§			  => դ2Х(big-endian) */
void alaw_to_sig2b(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* դ2Х(big-endian)	  => դ2Х(big-endian) */
void sig2b_to_sig2b(CONST_SHORT_PTR source,
		    SHORT_PTR	    target,
		    int		    nbytes);

/* ʤ2Х(big-endian)	  => դ2Х(big-endian) */
void unsig2b_to_sig2b(CONST_UNSIGNED_SHORT_PTR source,
		      SHORT_PTR		       target,
		      int		       nbytes);

/* դ2Х(little-endian) => դ2Х(big-endian) */
void sig2l_to_sig2b(CONST_SHORT_PTR source,
		    SHORT_PTR	    target,
		    int		    nbytes);

/* ʤ2Х(little-endian) => դ2Х(big-endian) */
void unsig2l_to_sig2b(CONST_UNSIGNED_SHORT_PTR source,
		      SHORT_PTR		       target,
		      int		       nbytes);

/* դ1Х		  => դ2Х(little-endian) */
void sig1_to_sig2l(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* ʤ1Х		  => դ2Х(little-endian) */
void unsig1_to_sig2l(CONST_UNSIGNED_CHAR_PTR source,
		     SHORT_PTR		     target,
		     int		     nbytes);

/* ˡ§			  => դ2Х(little-endian) */
void ulaw_to_sig2l(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* ˡ§			  => դ2Х(little-endian) */
void alaw_to_sig2l(CONST_CHAR_PTR source,
		   SHORT_PTR	  target,
		   int		  nbytes);

/* դ2Х(big-endian)	  => դ2Х(little-endian) */
void sig2b_to_sig2l(CONST_SHORT_PTR source,
		    SHORT_PTR	    target,
		    int		    nbytes);

/* ʤ2Х(big-endian)	  => դ2Х(little-endian) */
void unsig2b_to_sig2l(CONST_UNSIGNED_SHORT_PTR source,
		      SHORT_PTR		       target,
		      int		       nbytes);

/* դ2Х(little-endian) => դ2Х(little-endian) */
void sig2l_to_sig2l(CONST_SHORT_PTR source,
		    SHORT_PTR	    target,
		    int		    nbytes);

/* ʤ2Х(little-endian) => դ2Х(little-endian) */
void unsig2l_to_sig2l(CONST_UNSIGNED_SHORT_PTR source,
		      SHORT_PTR		       target,
		      int		       nbytes);

/* դ1Х		  => ʤ2Х(big-endian) */
void sig1_to_unsig2b(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* ʤ1Х		  => ʤ2Х(big-endian) */
void unsig1_to_unsig2b(CONST_UNSIGNED_CHAR_PTR source,
		     UNSIGNED_SHORT_PTR	     target,
		     int		     nbytes);

/* ˡ§			  => ʤ2Х(big-endian) */
void ulaw_to_unsig2b(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* ˡ§			  => ʤ2Х(big-endian) */
void alaw_to_unsig2b(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* դ2Х(big-endian)	  => ʤ2Х(big-endian) */
void sig2b_to_unsig2b(CONST_SHORT_PTR	 source,
		    UNSIGNED_SHORT_PTR target,
		    int		       nbytes);

/* ʤ2Х(big-endian)	  => ʤ2Х(big-endian) */
void unsig2b_to_unsig2b(CONST_UNSIGNED_SHORT_PTR source,
		      UNSIGNED_SHORT_PTR       target,
		      int		       nbytes);

/* դ2Х(little-endian) => ʤ2Х(big-endian) */
void sig2l_to_unsig2b(CONST_SHORT_PTR	 source,
		    UNSIGNED_SHORT_PTR target,
		    int		       nbytes);

/* ʤ2Х(little-endian) => ʤ2Х(big-endian) */
void unsig2l_to_unsig2b(CONST_UNSIGNED_SHORT_PTR source,
		      UNSIGNED_SHORT_PTR       target,
		      int		       nbytes);

/* դ1Х		  => ʤ2Х(little-endian) */
void sig1_to_unsig2l(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* ʤ1Х		  => ʤ2Х(little-endian) */
void unsig1_to_unsig2l(CONST_UNSIGNED_CHAR_PTR source,
		     UNSIGNED_SHORT_PTR		      target,
		     int		     nbytes);

/* ˡ§			  => ʤ2Х(little-endian) */
void ulaw_to_unsig2l(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* ˡ§			  => ʤ2Х(little-endian) */
void alaw_to_unsig2l(CONST_CHAR_PTR	source,
		   UNSIGNED_SHORT_PTR target,
		   int		      nbytes);

/* դ2Х(big-endian)	  => ʤ2Х(little-endian) */
void sig2b_to_unsig2l(CONST_SHORT_PTR	 source,
		    UNSIGNED_SHORT_PTR target,
		    int		       nbytes);

/* ʤ2Х(big-endian)	  => ʤ2Х(little-endian) */
void unsig2b_to_unsig2l(CONST_UNSIGNED_SHORT_PTR source,
		      UNSIGNED_SHORT_PTR       target,
		      int		       nbytes);

/* դ2Х(little-endian) => ʤ2Х(little-endian) */
void sig2l_to_unsig2l(CONST_SHORT_PTR	 source,
		    UNSIGNED_SHORT_PTR target,
		    int		       nbytes);

/* ʤ2Х(little-endian) => ʤ2Х(little-endian) */
void unsig2l_to_unsig2l(CONST_UNSIGNED_SHORT_PTR source,
		      UNSIGNED_SHORT_PTR       target,
		      int		       nbytes);

/* ʲѴؿѰդƤޤ
դ1Х		       => ʤ1Х
ʤ1Х		       => ʤ1Х
ˡ§			       => ʤ1Х
ˡ§			       => ʤ1Х
դ2Х(big-endian)    => ʤ1Х
ʤ2Х(big-endian)    => ʤ1Х
դ2Х(little-endian) => ʤ1Х
ʤ2Х(little-endian) => ʤ1Х

դ1Х		       => դ1Х
ʤ1Х		       => դ1Х
ˡ§			       => դ1Х
ˡ§			       => դ1Х
դ2Х(big-endian)    => դ1Х
ʤ2Х(big-endian)    => դ1Х
դ2Х(little-endian) => դ1Х
ʤ2Х(little-endian) => դ1Х

դ1Х		       => ˡ§
ʤ1Х		       => ˡ§
ˡ§			       => ˡ§
ˡ§			       => ˡ§
դ2Х(big-endian)    => ˡ§
ʤ2Х(big-endian)    => ˡ§
դ2Х(little-endian) => ˡ§
ʤ2Х(little-endian) => ˡ§

դ1Х		       => ˡ§
ʤ1Х		       => ˡ§
ˡ§			       => ˡ§
ˡ§			       => ˡ§
դ2Х(big-endian)    => ˡ§
ʤ2Х(big-endian)    => ˡ§
դ2Х(little-endian) => ˡ§
ʤ2Х(little-endian) => ˡ§

դ1Х		       => դ2Х(big-endian)
ʤ1Х		       => դ2Х(big-endian)
ˡ§			       => դ2Х(big-endian)
ˡ§			       => դ2Х(big-endian)
դ2Х(big-endian)    => դ2Х(big-endian)
ʤ2Х(big-endian)    => դ2Х(big-endian)
դ2Х(little-endian) => դ2Х(big-endian)
ʤ2Х(little-endian) => դ2Х(big-endian)

դ1Х		       => դ2Х(little-endian)
ʤ1Х		       => դ2Х(little-endian)
ˡ§			       => դ2Х(little-endian)
ˡ§			       => դ2Х(little-endian)
դ2Х(big-endian)    => դ2Х(little-endian)
ʤ2Х(big-endian)    => դ2Х(little-endian)
դ2Х(little-endian) => դ2Х(little-endian)
ʤ2Х(little-endian) => դ2Х(little-endian)

դ1Х		       => ʤ2Х(big-endian)
ʤ1Х		       => ʤ2Х(big-endian)
ˡ§			       => ʤ2Х(big-endian)
ˡ§			       => ʤ2Х(big-endian)
դ2Х(big-endian)    => ʤ2Х(big-endian)
ʤ2Х(big-endian)    => ʤ2Х(big-endian)
դ2Х(little-endian) => ʤ2Х(big-endian)
ʤ2Х(little-endian) => ʤ2Х(big-endian)

դ1Х		       => ʤ2Х(little-endian)
ʤ1Х		       => ʤ2Х(little-endian)
ˡ§			       => ʤ2Х(little-endian)
ˡ§			       => ʤ2Х(little-endian)
դ2Х(big-endian)    => ʤ2Х(little-endian)
ʤ2Х(big-endian)    => ʤ2Х(little-endian)
դ2Х(little-endian) => ʤ2Х(little-endian)
ʤ2Х(little-endian) => ʤ2Х(little-endian)
*/

void (* select_converter(long encoding_from, long encoding_to, 
			 int* from_bpu, int* to_bpu))
			(void *, void *, int);
/* ǡѴؿ֤ޤбѴФǤʤä NULL 
 * ֤ޤ
 * encoding_from ˤѴ沽ꤷޤusffd 줿
 * ʤ顤ɤηǤ⹽ޤ
 * encoding_to	 ˤѴ沽ꤷޤUSFFD_G711_ULAW,
 * USFFD_G711_ALAW, USFFD_SIGWORDB Τ줫ηꤷƤ
 * from_bpu ˤѴη 1 ץΥХȿ
 * to_bpu ˤѴη 1 ץΥХȿꤵޤ
 */


/* ƥ쥪 =>  */
void stereo_to_mono(long encoding,
		    void* from,
		    void* to,
		    int nbytes);

/*  => ƥ쥪 */
void mono_to_stereo(long encoding,
		    void* from,
		    void* to,
		    int nbytes);

/* ͥΤߤФ */
void stereo_left_channel(long encoding,
			 void* from,
			 void* to,
			 int nbytes);

/* ͥΤߤФ */
void stereo_right_channel(long encoding,
			  void* from,
			  void* to,
			  int nbytes);

#endif /* ___SOUNDEX_H_ */
