#ifndef ___SOUNDSCOPE_H_
#define ___SOUNDSCOPE_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "ssdefs.h"
#include "misc.h"
#include "WinObj.h"

/* FIXME */
/* ¾Υץѹ°Ѳɤƻ뤹뤳ȡ*/
struct sound_volatiles
{
    short play_output;
    short play_volume;
    short record_input;
    short record_volume;
    short monitor_volume;
    short sig_user1_flag;
};
extern volatile struct sound_volatiles current_sound_volatiles;
extern volatile struct sound_volatiles orig_sound_volatiles;

extern struct _file_loader
{
    Bool load_flag;
    short** data;
    long nchannels;
    long block_align;
    long read_samples;
    long rest_samples;
    struct _AudioBuffer* load_buffer;
    void (* converter)(void *, void *, int);

#ifdef USE_FILE_MAP
    char* map_file;
    long map_file_size;
    long map_file_offset;
#endif /* USE_FILE_MAP */

    /* ʲϥ󥻥ܥ󤬲줿βΰ٤Υ */
    struct _AudioBuffer* backup_buffer;
    long orig_sample_rate;
    int orig_channels;
    int orig_encoding;
} file_loader;

extern struct _file_saver
{
    Bool save_flag;
    char* filename;
    int fd;
    short** data;
    long nchannels;
    long file_encoding;
    long block_align;
    long write_samples;
    long rest_samples;
    struct _AudioBuffer* save_buffer;
    void (* converter)(void *, void *, int);
} file_saver;

struct _SSFrame;		/* defined in ssframe.h */
struct _AudioPlayer;		/* defined in player.h */
struct _usffd;			/* defined in usffd.h */

/* From soundscope.c */
void exit_soundscope();
void soundscope_event_proc(Bool nonblocking);
void soundscope_slice_proc(void);
void set_audio_file_lock(Bool flag);
void update_ss_active_flag(void);
int  sample_to_play_slider_pos(struct _SSFrame* frame, long sample);
long play_slider_pos_to_sample(struct _SSFrame* frame, int pos);
void move_play_slider_position(struct _SSFrame* frame, long sample);
void soundscope_goto_sample(struct _SSFrame* frame, long sample);
void ss_garbage_collection(void);

/* From win.c */
void open_window(void);
void open_new_ssframe(struct _SSFrame* parent_frame);
void allow_close_window_proc(void);
void prohibit_close_window_proc(void);
void init_scope_pixmap(struct _SSFrame* frame);
void map_local_mode(struct _SSFrame* frame);

/* From winprocs.c */
void sstoplevel_event_handler(WinObj* obj, XEvent* e);
void play_button_proc(WinObj* obj, XEvent* e);
void stop_button_proc(WinObj* obj, XEvent* e);
void stop_and_rewind_button_proc(WinObj* obj, XEvent* e);
void fast_forward_button_proc(WinObj* obj, XEvent* e);
void fast_rewind_button_proc(WinObj* obj, XEvent* e);
void looping_button_proc(WinObj* obj, XEvent* e);
void play_slider_proc(HLimitedSlider* slider, XEvent* e);
void edit_slider_proc(HSimpleSlider* slider, XEvent* e);
Bool popup_waiting_hook(PopupMenuBase* m);
void sample_rate_popup_proc(PopupMenuBase* menu, char* name, int id);
void output_popup_proc(PopupMenuBase* menu, char* name, int id);
void encoding_popup_proc(PopupMenuBase* menu, char* name, int id);
void channel_popup_proc(PopupMenuBase* menu, char* name, int id);
void volume_slider_proc(HSimpleSlider* slider, XEvent* e);
void zoom_slider_proc(WinObj* obj, XEvent* e);
void change_scope_mode_proc(ChoiceButton* c, XEvent* e);
void forward_button_proc(WinObj* obj, XEvent* e);
void backward_button_proc(WinObj* obj, XEvent* e);
void fixme_here(WinObj* obj, XEvent* e);
void move_view_position(int diff);
void scope_zoom_gear_proc(VAdjustGear* zoom, XEvent* e);
int calc_log_wave_zoom(double zoom, int maxpos, long n);

/* From load.c */
void initialize_setup_file_load_window(void);
void file_popup_setup_file_load(struct _PopupMenuBase* m, char* name, int id);
void setup_file_load_cancel(WinObj* obj, XEvent* e);
void file_load_button_proc(WinObj* obj, XEvent* e);
void file_load_slice_proc(void);
void initialize_file_indicator_window(void);
void soundscope_usffd_recognizer(struct _usffd* usffd);
void update_file_indicator(long total, long n);
void close_file_indicator(void);
void open_file_indicator(const char* message,
			 void (* cancel_handler)(WinObj* obj, XEvent* e));


/* From save.c */
void file_popup_setup_file_save(struct _PopupMenuBase* m, char* name, int id);
void initialize_setup_file_save_window(void);
void setup_file_save_cancel(WinObj* obj, XEvent* e);
void file_save_slice_proc(void);

/* From record.c */
void initialize_record_window(void);
void record_slice_proc(void);
void file_popup_record(PopupMenuBase* menu, char* name, int id);

/* From equlzer.c */
void create_equlizer(struct _SSFrame* frame);
void open_equlizer_win_popup_proc(PopupMenuBase* menu, char* name, int id);
void redraw_equlizer_window(struct _SSFrame* frame);

/* From abc.c */
void initialize_abc(void);
int play_buffer(void);
void abc_stop_audio(void);
Bool abc_restart_audio(void);
Bool abc_add_player(struct _AudioPlayer* player);
void abc_remove_player(struct _AudioPlayer* player);
Bool abc_set_appropriate_device_sample_rate(void);
extern struct _AudioBucketFilter* audio_wave_adder;

/* aubuff.c */
void initialize_audio_buffer(void);

/* From icon.c */
void initialize_button_icon_pixmaps(Display* disp, GC gc,
				    Pixel fg, Pixel bg, Pixel mark_color,
				    Bool mono);

/* From repaint.c */
void repaint_frame_scope(struct _SSFrame* frame, long sample, Bool sync);
void get_scope_draw_region(struct _SSFrame* frame, int ch,
			   int* x, int* y, int* width, int* height);
void scope_event_handler(WinObj* obj, XEvent* e);
void get_current_fft_data(struct _SSFrame* frame, int ch, long sample);
void initialize_log_hz_table(double zoom, double* table_return);
void initialize_exp_hz_table(double zoom, double* table_return);
extern int repaint_y_min, repaint_y_max;

/* From scope_wave.c */
void scope_wave_draw_measure(struct _SSFrame* frame, Drawable win);
void init_scope_wave(struct _SSFrame* frame);
void draw_scope_wave(struct _SSFrame* frame, int ch, long sample);
void draw_display_scope_time(struct _SSFrame* frame, Drawable win,
			     double dscale);
void change_display_scope_time(struct _SSFrame* frame, Drawable win,
			       double dscale);

/* From scope_spectram.c */
void init_scope_spectram(struct _SSFrame* frame);
void draw_scope_spectram(struct _SSFrame* frame, int ch, long sample);

/* From scope_spectrogram.c */
void draw_scope_spectrogram(struct _SSFrame* frame, int ch, long scope_pos);
void draw_scope_color_spectrogram(struct _SSFrame* frame, int ch, long sample,
				  long call_cnt);

/* From scope_edit.c */
void scope_edit_move_cur(struct _SSFrame* frame, long sample);
void draw_edit_scope_wave(struct _SSFrame* frame);
void scope_edit_event_proc(struct _SSFrame* frame, XEvent* event);
void sound_edit_copy_popup(struct _PopupMenuBase* m, char* name, int id);
void sound_edit_cut_popup(struct _PopupMenuBase* m, char* name, int id);
void sound_edit_paste_popup(struct _PopupMenuBase* m, char* name, int id);
void sound_edit_merge_popup(struct _PopupMenuBase* m, char* name, int id);
void sound_edit_overwrite_popup(struct _PopupMenuBase* m, char* name, int id);
void edit_rview_event_handler(WinObj* obj, XEvent* e);
PUBLIC void sound_edit_fin_popup(PopupMenuBase* menu, char* name, int id);
PUBLIC void sound_edit_fout_popup(PopupMenuBase* menu, char* name, int id);

/* From srcustom.c */
void open_custom_window_popup(PopupMenuBase* menu, char* name, int id);
void create_srcustom(struct _SSFrame* frame);
void set_srvalue(struct _SSFrame* frame);

/* From resource.c */
void get_resource(void);

enum file_popup_items
{
    FILE_POPUP_OPEN,
    FILE_POPUP_SAVE,
    FILE_POPUP_RECORD,
    FILE_POPUP_QUIT
};

enum sound_attri_popup_items
{
    SOUND_ATTRI_SAMPLERATE,
    SOUND_ATTRI_OUTPUT,
    SOUND_ATTRI_ENCODING,
    SOUND_ATTRI_CHANNEL
};

enum sound_edit_popup_items
{
    SOUND_EDIT_COPY,
    SOUND_EDIT_CUT,
    SOUND_EDIT_PASTE,
    SOUND_EDIT_MERGE,
    SOUND_EDIT_OVERWRITE,
    SOUND_EDIT_FIN,
    SOUND_EDIT_FOUT
};

enum sound_win_popup_items
{
    WIN_POPUP_NEWWINDOW,
    WIN_POPUP_WINCLOSE,
    WIN_POPUP_FILTER,
    WIN_POPUP_SYSSTATUS
};


/* X  */
extern Display* disp;
extern GC     gc;		/* ǻȤ󤷤 gc. ե*/
extern GC     dashgc;
extern CharFont* font;		/* ƥѥե () */
extern int display_width, display_height; /* display 礭 */

/*  */
extern Pixel color_pixel1;
extern Pixel color_pixel2;
extern Pixel color_pixel3;
extern Pixel color_pixel4;
extern Pixel scope_fg;
extern Pixel scope_bg;
extern Pixel WinObj_fg;
extern Pixel WinObj_bg;
extern Pixel WinObj_mark_color;

/* WinObj */
extern WinObj* text_short_cut_list_popup;
extern WinObj* message_winobj;

/* ¾ */
extern long internal_encoding;
extern Bool audio_active_flag;	/* 椫ɤ */
extern Bool audio_record_flag;	/* Ͽ椫ɤ */
extern Bool ss_active_flag;	/* soundscope 椫ɤ */
extern Bool audio_file_lock_flag;
extern XPoint wave_points[MAX_NPOINTS]; /* ȷ */
extern double fft_data[FFTSIZE]; /* ڥȥ */
extern struct _SSFrame* open_file_target_frame;
extern struct _AudioBuffer* record_backup_buffer;
extern char* default_text_string;
extern char* WinObj_font8;
extern char* WinObj_font16;
extern char* WinObj_fg_name;
extern char* WinObj_bg_name;
extern Bool WinObj_reverse_color_flag;
extern char* disp_name;
extern char* default_short_cut_list;

#endif /* ___SOUNDSCOPE_H_ */
