#include <stdio.h>
#include <string.h>
#include "soundscope.h"
#include "player.h"
#include "ssframe.h"

SSFrame* all_frame_list = NULL;
static SSFrame* free_frame_chain_list = NULL;

SSFrame* alloc_ssframe(void)
{
    SSFrame* frame;
    AudioPlayer* player;

    if(free_frame_chain_list == NULL)
    {
	if((frame = (SSFrame *)xmalloc(sizeof(SSFrame))) == NULL)
	    return NULL;
	if((player = (AudioPlayer *)xmalloc(sizeof(AudioPlayer))) == NULL)
	{
	    xfree(frame);
	    return NULL;
	}
	frame->player = player;
    }
    else
    {
	frame = free_frame_chain_list;
	player = frame->player;
	free_frame_chain_list = free_frame_chain_list->next;
    }

    /* ٤ƤΥФ 0 ǽƤκݡplayer  NULL ˤʤä
     * ޤΤǤȤ᤹
     */
    memset(frame, 0, sizeof(SSFrame));
    frame->player = player;
    frame->ed_cur = -1;
    frame->ed_vratio = 0.0;
    frame->yzoom = 1.0;
    audio_player_initialize(player, frame);

    frame->next = all_frame_list;
    all_frame_list = frame;

    frame->zoom[SCOPE_WAVE]		= MIN_WAVE_ZOOM;
    frame->zoom[SCOPE_SPECTORAM]	= LOG_HZ_MIN_X1;
    frame->zoom[SCOPE_SPECTOROGRAM]	= LOG_HZ_MIN_X1;
    frame->zoom[SCOPE_EDIT]		= MIN_WAVE_ZOOM;

    return frame;
}

void delete_ssframe(SSFrame* frame)
{
    SSFrame* cur = all_frame_list;
    SSFrame* prev = NULL;

    if(frame == NULL || frame->toplevel == NULL)
	return;			/*  */

    /* all_frame_list ե졼 */

    /* Ū frame ݥ󥿤ĥΡɤ򸫤Ĥ롥*/
    while(cur)
    {
	if(cur == frame)
	    break;
	prev = cur;
	cur = cur->next;
    }

    if(cur == NULL)		/* ٤ե졼¸ߤʤ */
	return;

    if(prev == NULL)		/* Ƭ */
	all_frame_list = all_frame_list->next;
    else
	prev->next = cur->next;

    cur->next = free_frame_chain_list;
    free_frame_chain_list = cur;

    if(frame->toplevel == NULL)
	return;			/* ȤϺ */

    DestroyWinObj(frame->toplevel);
    DestroyWinObj(frame->file_popup);
    DestroyWinObj(frame->sound_attri_popup);
    DestroyWinObj(frame->sound_edit_popup);
    DestroyWinObj(frame->sound_win_popup);
    DestroyWinObj(frame->sample_rate_popup);
    DestroyWinObj(frame->output_popup);
    DestroyWinObj(frame->encoding_popup);
    DestroyWinObj(frame->channel_popup);
    DestroyWinObj(frame->equlizer);
    DestroyWinObj(frame->srcustom);

    if(frame->scope_pm != None)
    {
	XFreePixmap(disp, frame->scope_pm);
	XFreePixmap(disp, frame->ed_cur_pm);
	XFreePixmap(disp, frame->scope_background);
    }
    frame->toplevel = NULL;

    return;
}

int number_of_ssframes(void)
{
    int n;
    SSFrame* tail = all_frame_list;

    n = 0;
    while(tail)
    {
	if(SSFRAME_AVAILABLE(tail))
	    n++;
	tail = tail->next;
    }

    return n;
}

void SSFrameMapFuntion(void (* map_function)(SSFrame* frame))
{
    SSFrame* tail = all_frame_list;

    while(tail)
    {
	if(SSFRAME_AVAILABLE(tail))
	    map_function(tail);
	tail = tail->next;
    }
}
