#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/resource.h>
#include "timer.h"

#ifdef __osf__
#define SVR4
#endif

#if defined(nec_ews)
#define GETTIMEOFDAY_ONE_ARGUMENT
#endif

double get_current_calender_time(void)
{
    struct timeval tv;
    struct timezone dmy;

#ifdef GETTIMEOFDAY_ONE_ARGUMENT
    gettimeofday(&tv);
#else
    gettimeofday(&tv, &dmy);
#endif

    return (double)tv.tv_sec + (double)tv.tv_usec / 1000000.0 ;
}


#ifdef SVR4
#include <sys/times.h> /* for times() stuff */
#include <unistd.h> /* for sysconf () */

static struct tms old_time;
static int clock_tick = 0;

void set_laptime(void)		/* initialize laptime */
{
    times(&old_time);
}

double get_laptime(void)
{
    struct tms new_time;

    if (clock_tick == 0) {
	clock_tick = sysconf(_SC_CLK_TCK);
    }
    times(&new_time);

    return (double)(new_time.tms_utime - old_time.tms_utime) /
      (double)clock_tick;

}

#else

#ifdef DEBUG
int getrusage(int who, struct rusage* rusage);
#endif

static struct rusage old_time;

void set_laptime(void)
{
    getrusage(RUSAGE_SELF, &old_time); /* initialize laptime */
}

double get_laptime(void)
{
    struct rusage new_time;

    getrusage(RUSAGE_SELF,&new_time);
    return (double)(new_time.ru_utime.tv_sec  - old_time.ru_utime.tv_sec)
	+  (new_time.ru_utime.tv_usec - old_time.ru_utime.tv_usec) / 1000000.0;
}
#endif

#if 0 /* ftime version */
int ftime(struct timeb* tp);
double get_current_calender_time(void)
{
    struct timeb tmb;

    ftime(&tmb);

    return (double)tmb.time + (double)tmb.millitm / 1000.0;
}
#endif
