#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

void marge1(int fd1, int fd2, int ofd);
void marge2(int fd1, int fd2, int ofd);
int write_open(const char* file);
int read_open(const char* file);

void usage(void)
{
    fputs("Usage: channel_marge {1|2} infile1 infole2 outfile\n", stderr);
}

void main(int argc, char** argv)
{
    char *file1, *file2, *ofile;
    int fd1, fd2, ofd;

    if(argc != 5)
    {
	usage();
	exit(1);
    }

    file1 = argv[2];
    file2 = argv[3];
    ofile = argv[4];

    fd1 = read_open(file1);
    fd2 = read_open(file2);
    ofd = write_open(ofile);

    if(!strcmp(argv[1], "1"))
	marge1(fd1, fd2, ofd);
    else if(!strcmp(argv[1], "2"))
	marge2(fd1, fd2, ofd);
    else
    {
	usage();
	exit(1);
    }
    exit(0);
}

int write_open(const char* file)
{
    int fd;

    if(!strcmp(file, "-"))
	return 1;

    if((fd = open(file, O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0)
    {
	perror(file);
	exit(1);
    }

    return fd;
}

int read_open(const char* file)
{
    int fd;

    if(!strcmp(file, "-"))
	return 0;

    if((fd = open(file, O_RDONLY)) < 0)
    {
	perror(file);
	exit(1);
    }

    return fd;
}

int set_zero(char* buff, int start, int buffsize)
{
    if(start < 0)
	start = 0;
    else if(start > buffsize)
	start = buffsize;
    memset(buff + start, 0, buffsize - start);
    return start;
}

void marge1(int fd1, int fd2, int ofd)
{
    char buff1[BUFSIZ];
    char buff2[BUFSIZ];
    char obuff[BUFSIZ*2];
    int i, n1, n2, n;

    while(1)
   {
	n1 = read(fd1, buff1, BUFSIZ);
	n2 = read(fd2, buff2, BUFSIZ);

	if(n1 < n2)
	    n = n2;
	else
	    n = n1;
	if(n1 != BUFSIZ)
	    n1 = set_zero(buff1, n1, BUFSIZ);
	if(n2 != BUFSIZ)
	    n2 = set_zero(buff2, n2, BUFSIZ);
	if(n1 == 0 && n2 == 0)
	    break;
	for(i = 0; i < n; i++)
	{
	    obuff[i * 2    ] = buff1[i];
	    obuff[i * 2 + 1] = buff2[i];
	}
	write(ofd, obuff, 2 * n);
    }
}

void marge2(int fd1, int fd2, int ofd)
{
    short buff1[BUFSIZ];
    short buff2[BUFSIZ];
    short obuff[BUFSIZ*2];
    int i, n1, n2, n;

    while(1)
    {
	n1 = read(fd1, buff1, BUFSIZ * sizeof(short));
	n2 = read(fd2, buff2, BUFSIZ * sizeof(short));

	if(n1 < n2)
	    n = n2 / sizeof(short);
	else
	    n = n1 / sizeof(short);
	if(n1 != n * sizeof(short))
	    n1 = set_zero((char *)buff1, n1, BUFSIZ * sizeof(short));
	if(n2 != n * sizeof(short))
	    n2 = set_zero((char *)buff2, n2, BUFSIZ * sizeof(short));
	if(n1 == 0 && n2 == 0)
	    break;
	for(i = 0; i < n; i++)
	{
	    obuff[i * 2] = buff1[i];
	    obuff[i * 2 + 1] = buff2[i];
	}
	write(ofd, obuff, 2 * n * sizeof(short));
    }
}
