#ifndef ___LIBCOMPRESS_H_
#define ___LIBCOMPRESS_H_

#define MAX_STATE 64

/*
 * state_id: global state
 *           You can select this value between 0 and (MAX_STATE-1)
 * n: number of elements in data
 * obuff: out buffer
 */

/* ulaw compressor */
void do_ulcompress4(int state_id, const unsigned char* data, long n, char* obuff);
void do_ulcompress3(int state_id, const unsigned char* data, long n, char* obuff);
void do_ulcompress2(int state_id, const unsigned char* data, long n, char* obuff);

/* ulaw decompressor */
void do_uldecompress4(int state_id, const unsigned char* data, long n, char* obuff);
void do_uldecompress3(int state_id, const unsigned char* data, long n, char* obuff);
void do_uldecompress2(int state_id, const unsigned char* data, long n, char* obuff);

/* signed word compressor */
void do_swcompress4(int state_id, const short* data, long n, unsigned char* obuff);
void do_swcompress3(int state_id, const short* data, long n, unsigned char* obuff);
void do_swcompress2(int state_id, const short* data, long n, unsigned char* obuff);

/* signed word decompressor */
void do_swdecompress4(int state_id, const unsigned char* data, long n, short* obuff);
void do_swdecompress3(int state_id, const unsigned char* data, long n, short* obuff);
void do_swdecompress2(int state_id, const unsigned char* data, long n, short* obuff);

void clear_compress_state(int state_id); /* -1 mean clear all state */

#endif /* ___LIBCOMPRESS_H_ */
