#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "audio_cnv.h"

int file_open(const char* name, int mode)
{
    int fd;

    if(O_CREAT & mode)
    {
	if((fd = open(name, mode, 0644)) < 0)
	{
	    perror(name);
	    exit(1);
	}
    }
    else
    {
	if((fd = open(name, mode)) < 0)
	{
	    perror(name);
	    exit(1);
	}
    }
    return fd;
}

void usage(void)
{
    fputs("Usage: ul2sw\n", stderr);
    fputs("       ul2sw infile [outfile]\n", stderr);
}

void main(int argc, char** argv)
{
    int ifd, ofd, n, i;
    char obuff[BUFSIZ];
    short ibuff[BUFSIZ];

    if(argc == 1)
    {
	ifd = 0;
	ofd = 1;
    }
    else if(argc == 2)
    {
	if(!strcmp(argv[1], "-"))
	    ifd = 0;
	else
	    ifd = file_open(argv[1], O_RDONLY);

	ofd = 1;
    }
    else if(argc == 3)
    {
	if(!strcmp(argv[1], "-"))
	    ifd = 0;
	else
	    ifd = file_open(argv[1], O_RDONLY);
	if(!strcmp(argv[2], "-"))
	    ofd = 0;
	else
	    ofd = file_open(argv[2], O_WRONLY | O_CREAT | O_TRUNC);
    }
    else
    {
	usage();
	exit(1);
    }

    while((n = read(ifd, ibuff, BUFSIZ * sizeof(short))) > 0)
    {
	n /= sizeof(short);
	for(i = 0; i < n; i++)
	    obuff[i] = AUDIO_S2U(ibuff[i]);
	write(ofd, obuff, n);
    }
    if(n < 0)
    {
	perror("read");
	close(ifd);
	close(ofd);
	exit(1);
    }

    close(ifd);
    close(ofd);
    exit(0);
}
