#include <stdio.h>
#include "audio_cnv.h"

void usage(void)
{
    fputs("Usage: uldiff file1, file2\n", stderr);
}

FILE* fileopen(const char* f, const char* m)
{
    FILE* fp;

    if((fp = fopen(f, m)) == NULL)
    {
	perror(f);
	exit(1);
    }

    return fp;
}

void main(int argc, char** argv)
{
    FILE *fp1, *fp2;
    int i1, i2;
    char c1, c2;
    short s1, s2;
    double dsum, d;
    long n;

    if(argc != 3)
    {
	usage();
	exit(1);
    }

    fp1 = fileopen(argv[1], "r");
    fp2 = fileopen(argv[2], "r");

    dsum = 0.0;
    n = 0;
    while((i1 = getc(fp1)) != EOF &&
	  (i2 = getc(fp2)) != EOF)
    {
	c1 = i1;
	c2 = i2;
	s1 = AUDIO_U2S(c1);
	s2 = AUDIO_U2S(c2);

	if(s1 == 0)
	    continue;
	d = (s1 - s2) / s1;
	if(d < 0)
	    d = -d;
	dsum += d;
	n++;
    }

    if(dsum == 0)
	puts("no error");
    else
	printf("error: %.2e%%\n", dsum / n * 100);
    exit(0);
}
